/******************************************************************************
* VAo̓foCX`wb_ (SH7262)                                   *
*                                                                             *
*  File name : nos7262.h                                                      *
*  Copyright (c) 2010, MiSPO Co., Ltd.                                        *
*  All rights reserved.                                                       *
*                                                                             *
* 2010-09-24 Created                                                       SZ *
******************************************************************************/

#ifndef _NOS_SH7262_H_
#define _NOS_SH7262_H_

#ifdef __cplusplus
extern "C" {
#endif

/* VA[hWX^(SCSMR) */

#define SMR_CKS0    0x0001  /* NbNZNg0 */
#define SMR_CKS1    0x0002  /* NbNZNg1 */
#define SMR_STOP    0x0008  /* 1Xgbvrbg(0), 2Xgbvrbg(1) */
#define SMR_OE      0x0010  /* peB(0), peB(1) */
#define SMR_PE      0x0020  /* peBCl[u */
#define SMR_CHR     0x0040  /* 8rbgf[^(0), 7rbgf[^(1) */
#define SMR_CA      0x0080  /* [h(0), NbN[h(1) */

/* VARg[WX^(SCSCR) */

#define SCR_CKE0    0x0001  /* NbNCl[u0 */
#define SCR_CKE1    0x0002  /* NbNCl[u1 */
#define SCR_REIE    0x0008  /* V[uG[C^vgCl[u */
#define SCR_RE      0x0010  /* MCl[u */
#define SCR_TE      0x0020  /* MCl[u */
#define SCR_RIE     0x0040  /* Mf[^t^MG[荞݃Cl[u */
#define SCR_TIE     0x0080  /* Mf[^GveB荞݃Cl[u */

/* VAXe[^XWX^(SCFSR) */

#define FSR_DR      0x0001  /* Mf[^fB */
#define FSR_RDF     0x0002  /* MFIFOt */
#define FSR_PER     0x0004  /* peBG[ */
#define FSR_FER     0x0008  /* t[~OG[ */
#define FSR_BRK     0x0010  /* u[No */
#define FSR_TDFE    0x0020  /* MFIFOf[^GveB */
#define FSR_TEND    0x0040  /* MI */
#define FSR_ER      0x0080  /* MG[ */
#define SSR_FER0    0x0100  /* t[~OG[0 */
#define SSR_FER1    0x0200  /* t[~OG[1 */
#define SSR_FER2    0x0400  /* t[~OG[2 */
#define SSR_FER3    0x0800  /* t[~OG[3 */
#define SSR_PER0    0x1000  /* peBG[0 */
#define SSR_PER1    0x2000  /* peBG[1 */
#define SSR_PER2    0x4000  /* peBG[2 */
#define SSR_PER3    0x8000  /* peBG[3 */

/* FIFORg[WX^(SCFCR) */

#define FCR_LOOP    0x0001  /* [vobNeXg */
#define FCR_RFRST   0x0002  /* V[uFIFOf[^WX^Zbg */
#define FCR_TFRST   0x0004  /* gX~bgFIFOf[^WX^Zbg */
#define FCR_MCE     0x0008  /* fRg[Cl[u */
#define FCR_TTRG0   0x0010  /* gX~bgFIFOf[^gK0 */
#define FCR_TTRG1   0x0020  /* gX~bgFIFOf[^gK1 */
#define FCR_RTRG0   0x0040  /* V[uFIFOf[^gK0 */
#define FCR_RTRG1   0x0080  /* V[uFIFOf[^gK1 */
#define FCR_RSTRG0  0x0100  /* RTSo̓ANeBugK0 */
#define FCR_RSTRG1  0x0200  /* RTSo̓ANeBugK1 */
#define FCR_RSTRG2  0x0400  /* RTSo̓ANeBugK2 */

/* VA|[gWX^ (SCSPTR) */

#define SPTR_SPB2DT 0x0001  /* VAf[^u[Nf[^ */
#define SPTR_SPB2IO 0x0002  /* VA|[gu[No */
#define SPTR_SCKDT  0x0004  /* SCK|[go */
#define SPTR_SCKIO  0x0005  /* SCK|[gf[^ */
#define SPTR_CTSDT  0x0010  /* CTS|[go */
#define SPTR_CTSIO  0x0020  /* CTS|[gf[^ */
#define SPTR_RTSDT  0x0040  /* RTS|[gf[^ */
#define SPTR_RTSIO  0x0080  /* RTS|[go */

/* CXe[^XWX^ (SCLSR) */

#define LSR_ORER    0x01    /* I[oG[ */

/* VAg[hWX^ (SCEMR) */

#define EMR_ABCS    0x0001  /* {NbNZNg */
#define EMR_BGDM    0x0080  /* {[[gWFl[^{[h */


/* st@NVRg[ (SCIFo͒[q̒`) */

#define RxD0_Port   IO_PJCR0    /* RxD0 Rg[WX^ */
#define RxD0_Func   0x0040      /* RxD0 [q@\ */
#define RxD0_Mask   0x0070      /* RxD0 [q@\}XN */

#define TxD0_Port   IO_PJCR0    /* TxD0 Rg[WX^ */
#define TxD0_Func   0x0004      /* TxD0 [q@\ */
#define TxD0_Mask   0x0007      /* TxD0 [q@\}XN */

#define RxD1_Port   IO_PGCR3    /* RxD1 Rg[WX^ */
#define RxD1_Func   0x0004      /* RxD1 [q@\ */
#define RxD1_Mask   0x0007      /* RxD1 [q@\}XN */

#define TxD1_Port   IO_PGCR3    /* TxD1 Rg[WX^ */
#define TxD1_Func   0x0040      /* TxD1 [q@\ */
#define TxD1_Mask   0x0070      /* TxD1 [q@\}XN */

#define RxD2_Port   IO_PFCR0    /* RxD2 Rg[WX^ */
#define RxD2_Func   0x0040      /* RxD2 [q@\ */
#define RxD2_Mask   0x0070      /* RxD2 [q@\}XN */

#define TxD2_Port   IO_PFCR0    /* TxD2 Rg[WX^ */
#define TxD2_Func   0x0400      /* TxD2 [q@\ */
#define TxD2_Mask   0x0700      /* TxD2 [q@\}XN */

#define RTS2_Port   0           /* RTS2 Rg[WX^ */
#define RTS2_Func   0x0000      /* RTS2 [q@\ */
#define RTS2_Mask   0x0000      /* RTS2 [q@\}XN */

#define CTS2_Port   0           /* CTS2 Rg[WX^ */
#define CTS2_Func   0x0000      /* CTS2 [q@\ */
#define CTS2_Mask   0x0000      /* CTS2 [q@\}XN */

#define RxD3_Port   IO_PFCR0    /* RxD3 Rg[WX^ */
#define RxD3_Func   0x4000      /* RxD3 [q@\ */
#define RxD3_Mask   0x7000      /* RxD3 [q@\}XN */

#define TxD3_Port   IO_PFCR1    /* TxD3 Rg[WX^ */
#define TxD3_Func   0x0004      /* TxD3 [q@\ */
#define TxD3_Mask   0x0007      /* TxD3 [q@\}XN */

#define RTS3_Port   0           /* RTS3 Rg[WX^ */
#define RTS3_Func   0x0000      /* RTS3 [q@\ */
#define RTS3_Mask   0x0000      /* RTS3 [q@\}XN */

#define CTS3_Port   0           /* CTS3 Rg[WX^ */
#define CTS3_Func   0x0000      /* CTS3 [q@\ */
#define CTS3_Mask   0x0000      /* CTS3 [q@\}XN */

#define RxD4_Port   IO_PGCR2    /* RxD4 Rg[WX^ */
#define RxD4_Func   0x0004      /* RxD4 [q@\ */
#define RxD4_Mask   0x0007      /* RxD4 [q@\}XN */

#define TxD4_Port   IO_PGCR2    /* TxD4 Rg[WX^ */
#define TxD4_Func   0x0040      /* TxD4 [q@\ */
#define TxD4_Mask   0x0070      /* TxD4 [q@\}XN */

#define RxD5_Port   IO_PGCR2    /* RxD5 Rg[WX^ */
#define RxD5_Func   0x0004      /* RxD5 [q@\ */
#define RxD5_Mask   0x0007      /* RxD5 [q@\}XN */

#define TxD5_Port   IO_PGCR2    /* TxD5 Rg[WX^ */
#define TxD5_Func   0x0040      /* TxD5 [q@\ */
#define TxD5_Mask   0x0070      /* TxD5 [q@\}XN */

#define RxD6_Port   IO_PGCR4    /* RxD6 Rg[WX^ */
#define RxD6_Func   0x0040      /* RxD6 [q@\ */
#define RxD6_Mask   0x0070      /* RxD6 [q@\}XN */

#define TxD6_Port   IO_PGCR4    /* TxD6 Rg[WX^ */
#define TxD6_Func   0x0400      /* TxD6 [q@\ */
#define TxD6_Mask   0x0700      /* TxD6 [q@\}XN */

#define RxD7_Port   IO_PGCR4    /* RxD7 Rg[WX^ */
#define RxD7_Func   0x4000      /* RxD7 [q@\ */
#define RxD7_Mask   0x7000      /* RxD7 [q@\}XN */

#define TxD7_Port   IO_PGCR5    /* TxD7 Rg[WX^ */
#define TxD7_Func   0x0004      /* TxD7 [q@\ */
#define TxD7_Mask   0x0007      /* TxD7 [q@\}XN */

#ifdef __cplusplus
}
#endif
#endif /* _NOS7262_H_ */
