/*******************************************************************************
* VAo̓hCo (SH7262 SCIF)                                         *
*                                                                              *
*  File name : nos7262.c                                                       *
*  Copyright (c)2010, MiSPO Co., Ltd.                                          *
*  All rights reserved.                                                        *
*                                                                              *
*  Compile : shc -cp=sh2afpu -op=1 -def=CLK=? nos7262.c      (Renesas C)       *
*                                                                              *
* 2010-09-24 Created                                                        SZ *
*******************************************************************************/

/*

œKRpC

          ݃nh܂܂̂ŁAKœKIvVtăRpC
          ĂB


`lԍ̎w

          CH}NŁA_`lԍwł܂B (w莞́ACH=0)
          CH 0`7wł܂B

          CH?}NŁA`lԍύXł܂B0`7wł܂B
          `lԍARg[̊֌Ŵ͎悤ɂȂĂ܂B

             `l   | Rg[̎ӉH
            ----------------+------------------------
              CH0           | SCIF0
              CH1           | SCIF1
              CH2           | SCIF2
              CH3           | SCIF3
              CH4           | SCIF4
              CH5           | SCIF5
              CH6           | SCIF6
              CH7           | SCIF7

          `lԍ̃}N`ȂꍇA_`lCH=?̔ԍ
          `lCH?̔ԍ͓ƂȂAʏ͕`l`
          Kv͂܂B
          CH1CH=0ɊtꍇȂǂ́A`lԍ̃}N𗘗p
          B

          ̃`lNꍇ́A_/`ldA
          AW[dȂ悤ɃRpCĂB

          () shc <options> nosXXX.c                           ... `l0
               shc <options> -def=CH=1 -ob nosXXX1.obj nosXXX.c ... `l1
                                  ~~~~ ~~~~~~~~~~~~~~

{[[gWFl[^

          \[XNbÑftHg 24 MHz łBύXꍇ
          CLK }N`ăRpCĂB
          l [Hz] Pʂ̎głB

          () shc <options> -def=CLK=50000000 nosXXX.c ... 50 MHz
                                  ~~~~~~~~~~~~

ONbN

          ONbNgpꍇAEXT_CLK}N`ĂB
          ONbN 1/16, 1/8 {[[gɂȂ܂B

           {o[Wł́AONbNNbN\[XƂ铮
             mFĂ܂B


Mobt@TCY̎w

          M/Mobt@̃TCYABUFSZ }Nɂ`ăRpC
          ĂBMobt@ƈقȂTCY̑Mobt@pꍇ
          ́A TXBUFSZ }N`ĂB
          w莞́AM/Mobt@ 1024oCgƂȂ܂B

          () Mobt@, Mobt@ 128oCg BUFSZ=128
          () Mobt@128, Mobt@ 64oCg BUFSZ=128, TXBUFSZ=64

          LN^̎MXe[^Xobt@OĂ̂ŁAۂ
          Mobt@̃TCY͏L̔{ƂȂ܂B


\tgEFAt[

          XON/XOFF LN^ɂt[pȂꍇANOXON}N
          `ăRpCĂBR[hTCYƏxߖł܂B


n[hEFAt[

          CH1, CH3́ASCIF̃fRg[@\𗘗pA
          \tgEFAɗ炸CTS, RTSɂn[hEFAt[𗘗p
          Ƃł܂Bn[hEFAt[𗘗pȂꍇANOFLW }N
          `ăRpCĂB

           {o[Wł́A̓mFĂ܂B
             - CH1, CH3 CTS, RTSɂn[hEFAt[
               (g{[hCQBB100Bł́AVA|[gRlN^/CTS, /RTSM
                ̂)


ݗD揇

          {nh̃ftHg̊ݗD揇ʂ́A7łB
          ύXꍇAIP}N`ăRpCĂB
          AJ[l荂Dɂ͂ł܂B (IP  KNL_LEVEL)
          {nh荂Dx̊݃nhLꍇAd݂N
          ܂B

          () shc <options> -def=IP=5 nosXXX.c ... ݗD揇 5
                                  ~~~~

T|[g@\

          - CH0CH7́ANbN[hT|[gĂ܂B


̑

          - CH2CH3́Ag{[hCQBB100B gpēmFĂ܂B
            ȊÕ`l͂ē얢mFłB

*/

#include <string.h>

#include "kernel.h"
#include "nosio.h"
#include "sh7262.h"

/* ݗD揇ʂ̒` */

#ifndef IP
#define IP          7               /* IP `Ȃ 7 Ƃ */
#endif

/* NbN̒` */

#ifndef CLK
#define CLK 24000000                /* ӃW[pNbN[Hz] */
#endif

/* Mobt@TCY̒` */

#ifndef BUFSZ
#define BUFSZ       1024            /* Mobt@ */
#endif
#ifndef TXBUFSZ
#define TXBUFSZ     BUFSZ           /* Mobt@ */
#endif

/* \tgEFAt[̒萔 */

#define XOFF_LEN    (BUFSZ*3/4)     /* XOFFMobt@ */
#define XON_LEN     (BUFSZ*1/4)     /* XON Mobt@ */

#define XOFF        0x13            /* M~LN^ (CTRL-S) */
#define XON         0x11            /* MĊJLN^ (CTRL-Q) */

/* n[hEFAt[ RTSANeBugKx */

#ifndef RTSTRG
#define RTSTRG      10
#endif

#if (RTSTRG >= 15)
#define RTSTRG_LVL  (0<<8)
#elif (RTSTRG >= 14)
#define RTSTRG_LVL  (7<<8)
#elif (RTSTRG >= 12)
#define RTSTRG_LVL  (6<<8)
#elif (RTSTRG >= 10)
#define RTSTRG_LVL  (5<<8)
#elif (RTSTRG >= 8)
#define RTSTRG_LVL  (4<<8)
#elif (RTSTRG >= 6)
#define RTSTRG_LVL  (3<<8)
#elif (RTSTRG >= 4)
#define RTSTRG_LVL  (2<<8)
#else
#define RTSTRG_LVL  (1<<8)
#endif

/* MFIFÕgKx */

#ifndef RCVTRG
#define RCVTRG      8
#endif

#ifndef TRNTRG
#define TRNTRG      2
#endif

#if (RCVTRG >= 14)
#define RCVFIFO_LVL (3<<6)
#elif (RCVTRG >= 8)
#define RCVFIFO_LVL (2<<6)
#elif (RCVTRG >= 4)
#define RCVFIFO_LVL (1<<6)
#else
#define RCVFIFO_LVL (0<<6)
#endif

#if (TRNTRG >= 8)
#define TRNFIFO_LVL (0<<4)
#elif (TRNTRG >= 4)
#define TRNFIFO_LVL (1<<4)
#elif (TRNTRG >= 2)
#define TRNFIFO_LVL (2<<4)
#else
#define TRNFIFO_LVL (3<<4)
#endif

/* _`lԍ (CH=0`7) */

#ifndef CH
#define CH          0               /* w̏ꍇ, _`l0 */
#endif

/* n̍ق̒ */

#if defined(__HITACHI__)            /* Renesas C */
 #include <machine.h>
#elif defined(__ghs)                /* Green Hills */
 #include <machine.h>
#else                               /* Renesas C */
 #error
#endif

/* `lԍ (CH0,CH1,...) */

#if (!defined(CH0) && !defined(CH1) && !defined(CH2) && !defined(CH3) \
      && !defined(CH4) && !defined(CH5) && !defined(CH6) && !defined(CH7))
 #if (CH==0)
  #define CH0               /* w̏ꍇ, _`l0 ̕`l0 */
 #elif (CH==1)
  #define CH1               /* w̏ꍇ, _`l1 ̕`l1 */
 #elif (CH==2)
  #define CH2               /* w̏ꍇ, _`l2 ̕`l2 */
 #elif (CH==3)
  #define CH3               /* w̏ꍇ, _`l3 ̕`l3 */
 #elif (CH==4)
  #define CH4               /* w̏ꍇ, _`l4 ̕`l4 */
 #elif (CH==5)
  #define CH5               /* w̏ꍇ, _`l5 ̕`l5 */
 #elif (CH==6)
  #define CH6               /* w̏ꍇ, _`l6 ̕`l6 */
 #elif (CH==7)
  #define CH7               /* w̏ꍇ, _`l7 ̕`l7 */
 #else
  #error Not Supported channel
 #endif
#endif

#include "nos7262.h"

/* CHx ɍ킹Ē` */

#ifdef CH0
#define SCIF_SCSMR  SCIF_SCSMR0
#define SCIF_SCBRR  SCIF_SCBRR0
#define SCIF_SCSCR  SCIF_SCSCR0
#define SCIF_SCFTDR SCIF_SCFTDR0
#define SCIF_SCFSR  SCIF_SCFSR0
#define SCIF_SCFRDR SCIF_SCFRDR0
#define SCIF_SCFCR  SCIF_SCFCR0
#define SCIF_SCFDR  SCIF_SCFDR0
#define SCIF_SCSPTR SCIF_SCSPTR0
#define SCIF_SCLSR  SCIF_SCLSR0
#define INT_ERIx    INT_ERI0
#define INT_RXIx    INT_RXI0
#define INT_TXIx    INT_TXI0
#define INT_BRIx    INT_BRI0
#define TxD_Port    TxD0_Port
#define TxD_Func    TxD0_Func
#define TxD_Mask    TxD0_Mask
#define RxD_Port    RxD0_Port
#define RxD_Func    RxD0_Func
#define RxD_Mask    RxD0_Mask
#define STBCRx      STBCR4
#define SYS_CLK     0x80
#define INTC_IPRLx  INTC_IPR17
#define DIS_INT     0xf000
#define ENA_INT     (IP << 12)
#define RTS_Port    0
#define RTS_Func    0x0000
#define RTS_Mask    0x0000
#define CTS_Port    0
#define CTS_Func    0x0000
#define CTS_Mask    0x0000
#endif

#ifdef CH1
#define SCIF_SCSMR  SCIF_SCSMR1
#define SCIF_SCBRR  SCIF_SCBRR1
#define SCIF_SCSCR  SCIF_SCSCR1
#define SCIF_SCFTDR SCIF_SCFTDR1
#define SCIF_SCFSR  SCIF_SCFSR1
#define SCIF_SCFRDR SCIF_SCFRDR1
#define SCIF_SCFCR  SCIF_SCFCR1
#define SCIF_SCFDR  SCIF_SCFDR1
#define SCIF_SCSPTR SCIF_SCSPTR1
#define SCIF_SCLSR  SCIF_SCLSR1
#define INT_ERIx    INT_ERI1
#define INT_RXIx    INT_RXI1
#define INT_TXIx    INT_TXI1
#define INT_BRIx    INT_BRI1
#define TxD_Port    TxD1_Port
#define TxD_Func    TxD1_Func
#define TxD_Mask    TxD1_Mask
#define RxD_Port    RxD1_Port
#define RxD_Func    RxD1_Func
#define RxD_Mask    RxD1_Mask
#define STBCRx      STBCR4
#define SYS_CLK     0x40
#define INTC_IPRLx  INTC_IPR17
#define DIS_INT     0x0f00
#define ENA_INT     (IP << 8)
#define RTS_Port    RTS1_Port
#define RTS_Func    RTS1_Func
#define RTS_Mask    RTS1_Mask
#define CTS_Port    CTS1_Port
#define CTS_Func    CTS1_Func
#define CTS_Mask    CTS1_Mask
#endif

#ifdef CH2
#define SCIF_SCSMR  SCIF_SCSMR2
#define SCIF_SCBRR  SCIF_SCBRR2
#define SCIF_SCSCR  SCIF_SCSCR2
#define SCIF_SCFTDR SCIF_SCFTDR2
#define SCIF_SCFSR  SCIF_SCFSR2
#define SCIF_SCFRDR SCIF_SCFRDR2
#define SCIF_SCFCR  SCIF_SCFCR2
#define SCIF_SCFDR  SCIF_SCFDR2
#define SCIF_SCSPTR SCIF_SCSPTR2
#define SCIF_SCLSR  SCIF_SCLSR2
#define INT_ERIx    INT_ERI2
#define INT_RXIx    INT_RXI2
#define INT_TXIx    INT_TXI2
#define INT_BRIx    INT_BRI2
#define TxD_Port    TxD2_Port
#define TxD_Func    TxD2_Func
#define TxD_Mask    TxD2_Mask
#define RxD_Port    RxD2_Port
#define RxD_Func    RxD2_Func
#define RxD_Mask    RxD2_Mask
#define STBCRx      STBCR4
#define SYS_CLK     0x20
#define INTC_IPRLx  INTC_IPR17
#define DIS_INT     0x00f0
#define ENA_INT     (IP << 4)
#define RTS_Port    0
#define RTS_Func    0x0000
#define RTS_Mask    0x0000
#define CTS_Port    0
#define CTS_Func    0x0000
#define CTS_Mask    0x0000
#endif

#ifdef CH3
#define SCIF_SCSMR  SCIF_SCSMR3
#define SCIF_SCBRR  SCIF_SCBRR3
#define SCIF_SCSCR  SCIF_SCSCR3
#define SCIF_SCFTDR SCIF_SCFTDR3
#define SCIF_SCFSR  SCIF_SCFSR3
#define SCIF_SCFRDR SCIF_SCFRDR3
#define SCIF_SCFCR  SCIF_SCFCR3
#define SCIF_SCFDR  SCIF_SCFDR3
#define SCIF_SCSPTR SCIF_SCSPTR3
#define SCIF_SCLSR  SCIF_SCLSR3
#define INT_ERIx    INT_ERI3
#define INT_RXIx    INT_RXI3
#define INT_TXIx    INT_TXI3
#define INT_BRIx    INT_BRI3
#define TxD_Port    TxD3_Port
#define TxD_Func    TxD3_Func
#define TxD_Mask    TxD3_Mask
#define RxD_Port    RxD3_Port
#define RxD_Func    RxD3_Func
#define RxD_Mask    RxD3_Mask
#define STBCRx      STBCR4
#define SYS_CLK     0x10
#define INTC_IPRLx  INTC_IPR17
#define DIS_INT     0x000f
#define ENA_INT     IP
#define RTS_Port    0
#define RTS_Func    0x0000
#define RTS_Mask    0x0000
#define CTS_Port    0
#define CTS_Func    0x0000
#define CTS_Mask    0x0000
#endif

#ifdef CH4
#define SCIF_SCSMR  SCIF_SCSMR4
#define SCIF_SCBRR  SCIF_SCBRR4
#define SCIF_SCSCR  SCIF_SCSCR4
#define SCIF_SCFTDR SCIF_SCFTDR4
#define SCIF_SCFSR  SCIF_SCFSR4
#define SCIF_SCFRDR SCIF_SCFRDR4
#define SCIF_SCFCR  SCIF_SCFCR4
#define SCIF_SCFDR  SCIF_SCFDR4
#define SCIF_SCSPTR SCIF_SCSPTR4
#define SCIF_SCLSR  SCIF_SCLSR4
#define INT_ERIx    INT_ERI4
#define INT_RXIx    INT_RXI4
#define INT_TXIx    INT_TXI4
#define INT_BRIx    INT_BRI4
#define TxD_Port    TxD4_Port
#define TxD_Func    TxD4_Func
#define TxD_Mask    TxD4_Mask
#define RxD_Port    RxD4_Port
#define RxD_Func    RxD4_Func
#define RxD_Mask    RxD4_Mask
#define STBCRx      STBCR4
#define SYS_CLK     0x08
#define INTC_IPRLx  INTC_IPR18
#define DIS_INT     0xf000
#define ENA_INT     (IP << 12)
#define RTS_Port    0
#define RTS_Func    0x0000
#define RTS_Mask    0x0000
#define CTS_Port    0
#define CTS_Func    0x0000
#define CTS_Mask    0x0000
#endif

#ifdef CH5
#define SCIF_SCSMR  SCIF_SCSMR5
#define SCIF_SCBRR  SCIF_SCBRR5
#define SCIF_SCSCR  SCIF_SCSCR5
#define SCIF_SCFTDR SCIF_SCFTDR5
#define SCIF_SCFSR  SCIF_SCFSR5
#define SCIF_SCFRDR SCIF_SCFRDR5
#define SCIF_SCFCR  SCIF_SCFCR5
#define SCIF_SCFDR  SCIF_SCFDR5
#define SCIF_SCSPTR SCIF_SCSPTR5
#define SCIF_SCLSR  SCIF_SCLSR5
#define INT_ERIx    INT_ERI5
#define INT_RXIx    INT_RXI5
#define INT_TXIx    INT_TXI5
#define INT_BRIx    INT_BRI5
#define TxD_Port    TxD5_Port
#define TxD_Func    TxD5_Func
#define TxD_Mask    TxD5_Mask
#define RxD_Port    RxD5_Port
#define RxD_Func    RxD5_Func
#define RxD_Mask    RxD5_Mask
#define STBCRx      STBCR4
#define SYS_CLK     0x04
#define INTC_IPRLx  INTC_IPR18
#define DIS_INT     0x0f00
#define ENA_INT     (IP << 8)
#define RTS_Port    0
#define RTS_Func    0x0000
#define RTS_Mask    0x0000
#define CTS_Port    0
#define CTS_Func    0x0000
#define CTS_Mask    0x0000
#endif

#ifdef CH6
#define SCIF_SCSMR  SCIF_SCSMR6
#define SCIF_SCBRR  SCIF_SCBRR6
#define SCIF_SCSCR  SCIF_SCSCR6
#define SCIF_SCFTDR SCIF_SCFTDR6
#define SCIF_SCFSR  SCIF_SCFSR6
#define SCIF_SCFRDR SCIF_SCFRDR6
#define SCIF_SCFCR  SCIF_SCFCR6
#define SCIF_SCFDR  SCIF_SCFDR6
#define SCIF_SCSPTR SCIF_SCSPTR6
#define SCIF_SCLSR  SCIF_SCLSR6
#define INT_ERIx    INT_ERI6
#define INT_RXIx    INT_RXI6
#define INT_TXIx    INT_TXI6
#define INT_BRIx    INT_BRI6
#define TxD_Port    TxD6_Port
#define TxD_Func    TxD6_Func
#define TxD_Mask    TxD6_Mask
#define RxD_Port    RxD6_Port
#define RxD_Func    RxD6_Func
#define RxD_Mask    RxD6_Mask
#define STBCRx      STBCR4
#define SYS_CLK     0x02
#define INTC_IPRLx  INTC_IPR18
#define DIS_INT     0x00f0
#define ENA_INT     (IP << 4)
#define RTS_Port    0
#define RTS_Func    0x0000
#define RTS_Mask    0x0000
#define CTS_Port    0
#define CTS_Func    0x0000
#define CTS_Mask    0x0000
#endif

#ifdef CH7
#define SCIF_SCSMR  SCIF_SCSMR7
#define SCIF_SCBRR  SCIF_SCBRR7
#define SCIF_SCSCR  SCIF_SCSCR7
#define SCIF_SCFTDR SCIF_SCFTDR7
#define SCIF_SCFSR  SCIF_SCFSR7
#define SCIF_SCFRDR SCIF_SCFRDR7
#define SCIF_SCFCR  SCIF_SCFCR7
#define SCIF_SCFDR  SCIF_SCFDR7
#define SCIF_SCSPTR SCIF_SCSPTR7
#define SCIF_SCLSR  SCIF_SCLSR7
#define INT_ERIx    INT_ERI7
#define INT_RXIx    INT_RXI7
#define INT_TXIx    INT_TXI7
#define INT_BRIx    INT_BRI7
#define TxD_Port    TxD7_Port
#define TxD_Func    TxD7_Func
#define TxD_Mask    TxD7_Mask
#define RxD_Port    RxD7_Port
#define RxD_Func    RxD7_Func
#define RxD_Mask    RxD7_Mask
#define STBCRx      STBCR4
#define SYS_CLK     0x01
#define INTC_IPRLx  INTC_IPR18
#define DIS_INT     0x000f
#define ENA_INT     IP
#define RTS_Port    0
#define RTS_Func    0x0000
#define RTS_Mask    0x0000
#define CTS_Port    0
#define CTS_Func    0x0000
#define CTS_Mask    0x0000
#endif

#if (CH==0)
 #define int_sio_rx  int_sio0_rx
 #define int_sio_tx  int_sio0_tx
 #define ini_sio     ini_sio0
 #define ext_sio     ext_sio0
 #define get_sio     get_sio0
 #define put_sio     put_sio0
 #define ctl_sio     ctl_sio0
 #define ref_sio     ref_sio0
 #define fls_sio     fls_sio0
#elif (CH==1)
 #define int_sio_rx  int_sio1_rx
 #define int_sio_tx  int_sio1_tx
 #define ini_sio     ini_sio1
 #define ext_sio     ext_sio1
 #define get_sio     get_sio1
 #define put_sio     put_sio1
 #define ctl_sio     ctl_sio1
 #define ref_sio     ref_sio1
 #define fls_sio     fls_sio1
#elif (CH==2)
 #define int_sio_rx  int_sio2_rx
 #define int_sio_tx  int_sio2_tx
 #define ini_sio     ini_sio2
 #define ext_sio     ext_sio2
 #define get_sio     get_sio2
 #define put_sio     put_sio2
 #define ctl_sio     ctl_sio2
 #define ref_sio     ref_sio2
 #define fls_sio     fls_sio2
#elif (CH==3)
 #define int_sio_rx  int_sio3_rx
 #define int_sio_tx  int_sio3_tx
 #define ini_sio     ini_sio3
 #define ext_sio     ext_sio3
 #define get_sio     get_sio3
 #define put_sio     put_sio3
 #define ctl_sio     ctl_sio3
 #define ref_sio     ref_sio3
 #define fls_sio     fls_sio3
 #endif

#if defined(__HITACHI__)
 #pragma interrupt(int_sio_rx(resbank))
 #pragma interrupt(int_sio_tx(resbank))
 #pragma ifunc(int_sio_rx)
 #pragma ifunc(int_sio_tx)
#endif

/* ݃nh` */

INTHDR int_sio_rx(void);
INTHDR int_sio_tx(void);

static const T_DINH dinh_sio_rx = { TA_HLNG, int_sio_rx, IP };
static const T_DINH dinh_sio_tx = { TA_HLNG, int_sio_tx, IP };

/* VAo͐ubN */

extern T_SIO SIO[];

/* ϐ */

static UB txbuf[TXBUFSZ];       /* Mobt@ */
static UB rxbuf[BUFSZ*2];       /* Mobt@, MXe[^Xobt@ */

/*******************************************************************************
* VAo͐ubN (֐)
*
*******************************************************************************/

static void init_buf(void)
{
    int init;

    /* ubNNA */

    init = SIO[CH].flag & TSF_INIT;
    memset(&SIO[CH], 0, sizeof SIO[CH]);
    SIO[CH].flag = (UB)init;
    SIO[CH].ch = CH;

    /* |C^ރZbgAbv */

    SIO[CH].txbuf = txbuf;          /* Mobt@ */
    SIO[CH].rxbuf = rxbuf;          /* Mobt@ */
    SIO[CH].txputp = SIO[CH].txbuf; /* Mobt@i[|C^l */
    SIO[CH].txgetp = SIO[CH].txbuf; /* Mobt@擾|C^l */
    SIO[CH].rxputp = SIO[CH].rxbuf; /* Mobt@i[|C^l */
    SIO[CH].rxgetp = SIO[CH].rxbuf; /* Mobt@擾|C^l */
}

/*******************************************************************************
* Xe[^X & ҏW (֐)
*
*    bit7                                      bit0
*   [ DSR | BD  | FE  | OE  | PE  |TXEMP| CTS | CD  ]
*     (1)                                       (1)
*
* DSR, CD  ̂ŏ펞 1 Ƃ
*******************************************************************************/

static int get_stat(void)
{
    int stat;
    int fsr;

    /* Xe[^X */

    fsr = sfr_inw(SCIF_SCFSR) & (FSR_TEND|FSR_BRK|FSR_FER|FSR_PER);
    fsr |= (SIO[CH].rxsts & (FSR_FER|FSR_PER|FSR_BRK));
                                                /* M̃Xe[^XOR */

    /* u[NOFFo */
    if (sfr_inw(SCIF_SCSPTR) & SPTR_SPB2DT)     /* RxD [q"1" */
        fsr &= ~FSR_BRK;

    /* Xe[^XrbgҏW */

    stat = TSIO_DSR|TSIO_CD|TSIO_CTS;   /* DSR, CD, CTS 펞ON */

    if (fsr & FSR_TEND)                 /* M */
        stat |= TSIO_TXEMP;
    if (fsr & FSR_PER)                  /* peBG[ */
        stat |= TSIO_PE;
    if (sfr_inw(SCIF_SCLSR) & 0x01)     /* I[o[G[ */
        stat |= TSIO_OE;
    if (fsr & FSR_FER)                  /* t[~OG[ */
        stat |= TSIO_FE;
    if (fsr & FSR_BRK)                  /* u[No */
        stat |= TSIO_BD;
    if (sfr_inw(SCIF_SCSPTR) & SPTR_CTSDT)   /* CTS  */
       stat &= ~TSIO_CTS;

    return stat;
}

/*******************************************************************************
* rhnfoCX (֐)
*
*******************************************************************************/

static BOOL init_sio(UW mode, UW baud)
{
  #ifndef EXT_CLK
    int cks;
    UW brr;
  #endif

    /* NbNJn */

    sfr_clr(STBCRx, SYS_CLK);

    /* Zbg */

    sfr_outw(SCIF_SCSCR, 0x0000);

    /* MFIFOf[^WX^Zbg */

    sfr_outw(SCIF_SCFCR, FCR_RFRST|FCR_TFRST);

    /* eXe[^XނNA */

    sfr_inw(SCIF_SCFSR);
    sfr_outw(SCIF_SCFSR, 0x0000);
    sfr_inw(SCIF_SCLSR);
    sfr_outw(SCIF_SCLSR, 0x0000);

    /* NbN̑IƏ */
  #ifdef EXT_CLK
    sfr_outw(SCIF_SCSCR, SCR_CKE1);
  #endif

    /* {[[gݒlvZ */
  #ifdef EXT_CLK
    sfr_outw(SCIF_SCSMR, (UW)(mode));
  #else
    baud <<= 5; /* 64~2^(-1)~B */
    for (cks = 0; cks < 4; cks++, baud <<= 2) {
        brr = ((CLK) / baud) - 1;
        if (brr <= 0xffL)
            break;
    }
    if (cks == 4)
        return FALSE;

    /* [h/{[[gݒ */

    sfr_outw(SCIF_SCSMR, (UW)(mode | cks));
    sfr_out(SCIF_SCBRR, (UB)(brr));
  #endif

    /* SCIF ł FIFO ݒ */

  #if (RTS_Port != 0)
    sfr_outw(SCIF_SCFCR, RTSTRG_LVL|RCVFIFO_LVL|TRNFIFO_LVL);
    if (SIO[CH].flag & TSF_RTS)
        sfr_setw(SCIF_SCFCR, FCR_MCE);   /* MCE = 1: fM */
  #else
    sfr_outw(SCIF_SCFCR, RCVFIFO_LVL|TRNFIFO_LVL);
  #endif

    /* st@NVRg[̐ݒ */

    sfr_outw(RxD_Port, (sfr_inw(RxD_Port) & ~RxD_Mask) | RxD_Func);
    sfr_outw(TxD_Port, (sfr_inw(TxD_Port) & ~TxD_Mask) | TxD_Func);
  #if (RTS_Port != 0)
    sfr_outw(RTS_Port, (sfr_inw(RTS_Port) & ~RTS_Mask) | RTS_Func);
  #endif
  #if (CTS_Port != 0)
    sfr_outw(CTS_Port, (sfr_inw(CTS_Port) & ~CTS_Mask) | CTS_Func);
  #endif

    return TRUE;
}

/*******************************************************************************
* VA݋֎~ (֐)
*
*******************************************************************************/

static void dis_int_sio(void)
{
    UINT psw;

    psw = vdis_psw();
    sfr_clrw(INTC_IPRLx, DIS_INT);
    vset_psw(psw);
}

/*******************************************************************************
* VA݋ (֐)
*
*******************************************************************************/

static void ena_int_sio(void)
{
    UINT psw;

    psw = vdis_psw();
    sfr_setw(INTC_IPRLx, ENA_INT);
      vset_psw(psw);
}

/*******************************************************************************
* Mobt@NA (֐)
*
*******************************************************************************/

static void clr_txbuf(void)
{
    UH fcr;

    SIO[CH].txcnt = 0;
    SIO[CH].txgetp = SIO[CH].txputp;

    /* MFIFONA */

    fcr = sfr_inw(SCIF_SCFCR);
    sfr_outw(SCIF_SCFCR, fcr | FCR_TFRST);
    sfr_outw(SCIF_SCFCR, fcr);
}

/*******************************************************************************
* Mobt@NA (֐)
*
*******************************************************************************/

static void clr_rxbuf(void)
{
    UH fcr;

    /* Mobt@NA */

    SIO[CH].rxsts = 0;
    SIO[CH].oldsts = 0;
    SIO[CH].eotcnt = 0;
    SIO[CH].rxcnt = 0;
    SIO[CH].rxgetp = SIO[CH].rxputp;

    /* XON/OFFt[̉ */

  #ifndef NOXON
    if (SIO[CH].flag & TSF_TXOFF)
    {   SIO[CH].flag |= TSF_TXREQ;  /* XON/XOFF MvZbg */
        sfr_setw(SCIF_SCSCR, SCR_TIE);  /* M݋ */
    }
  #endif

    /* MFIFONA */

    fcr = sfr_inw(SCIF_SCFCR);
    sfr_outw(SCIF_SCFCR, fcr | FCR_RFRST);
    sfr_outw(SCIF_SCFCR, fcr);
}

/*******************************************************************************
* Mobt@ւPi[ (֐)
*
* obt@tŊi[łȂꍇ́AFALSE ԂB
*******************************************************************************/

static BOOL put_txbuf(UB c)
{
    UB *p;

    /* obt@ + 1 */
    /* obt@t`FbN */

    if (++SIO[CH].txcnt > TXBUFSZ)
    {   SIO[CH].txcnt = TXBUFSZ;
        return FALSE;
    }

    /* obt@֊i[ */

    p = SIO[CH].txputp;
    *p = c;

    /* i[|C^Pi߂ */

    if (++p >= SIO[CH].txbuf + TXBUFSZ)
        p = SIO[CH].txbuf;
    SIO[CH].txputp = p;

    /* M݋ */

    sfr_setw(SCIF_SCSCR, SCR_TIE);

    return TRUE;
}

/*******************************************************************************
* Mobt@֎M/Xe[^Xi[ (֐)
*
*******************************************************************************/

static void put_rxbuf(void)
{
    int cnt;
    UB *p;

    /* Au[NȂi[Ȃ */

    if ((SIO[CH].rxsts & FSR_BRK) && (SIO[CH].oldsts & FSR_BRK))
        return;

    /* obt@t`FbN */

    cnt = SIO[CH].rxcnt;
    if (cnt == BUFSZ)
        return;
    if (++cnt == BUFSZ)
        SIO[CH].rxsts |= FSR_TEND;      /* I[ot[ TEND Ɋ蓖 */

    /* obt@ + 1 */

    SIO[CH].rxcnt = (UH)cnt;

    /* XON/OFFt[ */

  #ifndef NOXON
    if ((cnt == XOFF_LEN)
     && ((SIO[CH].flag & (TSF_XON|TSF_TXOFF)) == TSF_XON))
    {   SIO[CH].flag |= TSF_TXREQ;  /* XON/XOFF MvZbg */
        sfr_setw(SCIF_SCSCR, SCR_TIE);  /* M݋ */
    }
  #endif

    /* obt@֊i[ */
    /* I[o+1 */

    p = SIO[CH].rxputp;
    if ((*p = SIO[CH].rxchr) == SIO[CH].eot)
        SIO[CH].eotcnt++;
    *(p + BUFSZ) = SIO[CH].rxsts;

    /* i[|C^Pi߂ */

    if (++p >= SIO[CH].rxbuf + BUFSZ)
        p = SIO[CH].rxbuf;
    SIO[CH].rxputp = p;
}

/*******************************************************************************
* Mobt@P擾 (֐)
*
* obt@Ŏ擾łȂꍇ́A-1 ԂB
*******************************************************************************/

static int get_rxbuf(UB *c)
{
    int cnt;
    int sts;
    UB *p;

    /* Mobt@`FbN */

    cnt = SIO[CH].rxcnt;
    if (--cnt == -1)
        return cnt;

    /* Mobt@ - 1 */

    SIO[CH].rxcnt = (UH)cnt;

    /* XON/OFFt[ */

  #ifndef NOXON
    if ((cnt == XON_LEN)
     && (SIO[CH].flag & TSF_TXOFF))
    {   SIO[CH].flag |= TSF_TXREQ;      /* XON/XOFF MvZbg */
        sfr_setw(SCIF_SCSCR, SCR_TIE);      /* M݋ */
    }
  #endif

    /* Mobt@擾 */
    /* I[o-1 */

    p = SIO[CH].rxgetp;
    if ((*c = *p) == SIO[CH].eot)
        SIO[CH].eotcnt--;
    sts = *(p + BUFSZ);

    /* 擾|C^Pi߂ */

    if (++p >= SIO[CH].rxbuf + BUFSZ)
        p = SIO[CH].rxbuf;
    SIO[CH].rxgetp = p;

    return sts;
}

/*******************************************************************************
* M݃nh{ (֐)
*
*******************************************************************************/

static noinline void rx_int(void)
{
    int sts;
    int chr;
    int tid;

    while ((sfr_inw(SCIF_SCFDR) & 0x001F) != 0)
    {
        /* MXe[^X擾 */

        sts = sfr_inw(SCIF_SCFSR) & (FSR_FER|FSR_PER);

        /* u[No */

        if ((sts & FSR_FER)                        /* t[~OG[ */
         && !(sfr_inw(SCIF_SCSPTR) & SPTR_SPB2DT)) /* RxD [q"0" */
            sts |= FSR_BRK;

        /* Mf[^̓ǂݏo */

        chr = sfr_in(SCIF_SCFRDR);
        SIO[CH].oldsts = SIO[CH].rxsts;         /* O̎MXe[^XL */
        SIO[CH].rxsts = (UB)sts;
        SIO[CH].rxchr = (UB)chr;

        /* XON/OFFt[L̏ꍇ */

      #ifndef NOXON
        if (!(sts & (FSR_FER|FSR_PER)) && (SIO[CH].flag & TSF_XON))
        {
            /* XOFFMȂ瑗Mf */

            if (chr == XOFF)
            {   SIO[CH].flag |= TSF_RXOFF;
                continue;
            }

            /* XON MȂ瑗MĊJ */

            if (chr == XON)
            {   SIO[CH].flag &= ~TSF_RXOFF;
                sfr_setw(SCIF_SCSCR, SCR_TIE);  /* M݋ */
                continue;
            }
        }
      #endif

        /* Mobt@֊i[ */

        put_rxbuf();

        /* M҂ */

        if ((tid = SIO[CH].rxtid) != 0)
        {   SIO[CH].rxtid = 0;
            iwup_tsk((ID)tid);
        }
    }

    /* M݂NA */

    sfr_clrw(SCIF_SCFSR, (FSR_ER|FSR_BRK|FSR_FER|FSR_PER|FSR_RDF|FSR_DR));

    if (sfr_inw(SCIF_SCLSR) & LSR_ORER)     /* I[o[o */
    {
        sfr_outw(SCIF_SCLSR,0);             /* I[o[NA */
        SIO[CH].oldsts = SIO[CH].rxsts;     /* O̎MXe[^XL */
        SIO[CH].rxsts = FSR_RDF;            /* I[o[RDFɊ蓖 */
        SIO[CH].rxchr = 0xFF;               /* I[o[̃_~[f[^ */
        put_rxbuf();                        /* Mobt@֊i[ */
    }
}

/*******************************************************************************
* M݃nh
*
*******************************************************************************/

INTHDR int_sio_rx(void)
{
    ent_int();              /* ݃nh̊Jn */
    rx_int();               /* M݃nh{ */
    ret_int();              /* ݃nh畜A */
}

/*******************************************************************************
* M݃nh{ (֐)
*
*******************************************************************************/

static noinline void tx_int(void)
{
    UB *p;
    int tid;
    BOOL send_flag = FALSE;

    /* MfBZ[uȂ瑗MȂ */

    if (!(sfr_inw(SCIF_SCSCR) & SCR_TE))
    {   sfr_clrw(SCIF_SCSCR, SCR_TIE);          /* M݋֎~       */
        return;
    }

    /* MfBłȂΏI */

    if ((sfr_inw(SCIF_SCFDR) >> 8) < 16)        /* MFIFOɋ󂫗LH */
    {
        /* M˗ꂽXON/XOFF̑MD */

      #ifndef NOXON
        if (SIO[CH].flag & TSF_TXREQ)
        {   SIO[CH].flag &= ~TSF_TXREQ;
            if (SIO[CH].flag & TSF_TXOFF)
            {   SIO[CH].flag &= ~TSF_TXOFF;
                sfr_out(SCIF_SCFTDR, XON);
            }
            else
            {   SIO[CH].flag |= TSF_TXOFF;
                sfr_out(SCIF_SCFTDR, XOFF);
            }
            send_flag = TRUE;
        }

        /* XOFFMĂ瑗Ms */

        if (SIO[CH].flag & TSF_RXOFF)
        {   sfr_clrw(SCIF_SCSCR, SCR_TIE);      /* M݋֎~       */
            return;
        } else
      #endif

        while ((sfr_inw(SCIF_SCFDR) >> 8) < 16)
        {
            /* Mobt@ - 1 */
            /* Mobt@Ȃ瑗Ms */

            if (--SIO[CH].txcnt == (UH)-1)
            {
                SIO[CH].txcnt = 0;
                if (SIO[CH].tetid != 0)         /* SCIFł͂       */
                    iwup_tsk(SIO[CH].tetid);    /* MI҂     */
                sfr_clrw(SCIF_SCSCR, SCR_TIE);  /* M݋֎~       */
                break;
            }

            /* PM */

            p = SIO[CH].txgetp;
            sfr_out(SCIF_SCFTDR, *p);
            send_flag = TRUE;

            /* 擾|C^Pi߂ */

            if (++p >= SIO[CH].txbuf + TXBUFSZ)
                p = SIO[CH].txbuf;
            SIO[CH].txgetp = p;

            /* M҂ */

            if ((tid = SIO[CH].txtid) != 0)
            {   SIO[CH].txtid = 0;
                iwup_tsk((ID)tid);
            }
        }
        if (send_flag)
        {   if (sfr_inw(SCIF_SCFSR) & FSR_TEND)
                sfr_outw(SCIF_SCFSR, (UB)~(FSR_FER|FSR_PER|FSR_TEND));
        }
    }
}

/*******************************************************************************
* M݃nh
*
*******************************************************************************/

INTHDR int_sio_tx(void)
{
    ent_int();              /* ݃nh̊Jn */
    tx_int();               /* M݃nh{ */
    ret_int();              /* ݃nh畜A */
}

/*******************************************************************************
* p[^ (֐)
*
*******************************************************************************/

static BOOL set_param(const char *s, UW *mode, UW *baud)
{
    char c;
    UW b;

    /* [h */

    *mode = 0;
    if      (strstr(s, (char *)"PE") != NULL)   *mode |= SMR_PE;
    else if (strstr(s, (char *)"PO") != NULL)   *mode |= SMR_PE|SMR_OE;
    if      (strstr(s, (char *)"S2") != NULL)   *mode |= SMR_STOP;
    if      (strstr(s, (char *)"B7") != NULL)   *mode |= SMR_CHR;

    /* t[L */

    if (strstr(s, (char *)"XON") != NULL)   SIO[CH].flag |= TSF_XON;
    if (strstr(s, (char *)"RTS") != NULL)   SIO[CH].flag |= TSF_RTS;

    /* I[w蔻 */

    if (strstr(s, (char *)"ETX") != NULL)   SIO[CH].eot = 0x03;
    if (strstr(s, (char *)"EOT") != NULL)   SIO[CH].eot = 0x04;
    if (strstr(s, (char *)"CR" ) != NULL)   SIO[CH].eot = 0x0d;
    if (strstr(s, (char *)"LF" ) != NULL)   SIO[CH].eot = 0x0a;

    /* {[[g */
    /* 3ȏ̐lĕϊ */

    for (;;)
    {
        c = *s++;
        if (c == '\0')
        {   *baud = 9600L;
            break;
        }
        if (c < '0' || c > '9')
            continue;
        c = *s++;
        if (c < '0' || c > '9')
            continue;
        c = *s++;
        if (c < '0' || c > '9')
            continue;

        s -= 3;
        b = 0L;
        for (;;)
        {   c = *s++;
            if (c < '0' || c > '9')
                break;
            b = b * 10 + (c - '0');
        }
        *baud = b;
        break;
    }
    return TRUE;
}

/*******************************************************************************
* VAo͏
*
*******************************************************************************/

ER ini_sio(const char *param)
{
    UW baud;
    UW mode;

    dis_int_sio();

    /* ubN */

    init_buf();

    /* p[^ */

    if (!set_param(param, &mode, &baud))
        return E_PAR;

    /* foCX */

    if (!init_sio(mode, baud))
        return E_PAR;

    /* ݃nh̒` */
        SIO[CH].flag |= TSF_INIT;
        def_inh(INT_ERIx, &dinh_sio_rx);
        def_inh(INT_RXIx, &dinh_sio_rx);
        def_inh(INT_TXIx, &dinh_sio_tx);
        def_inh(INT_BRIx, &dinh_sio_rx);

    /* M݋ */

    sfr_setw(SCIF_SCSCR, SCR_RIE);
    ena_int_sio();
    return E_OK;
}

/*******************************************************************************
* VAo͏I
*
*******************************************************************************/

void ext_sio(void)
{
    if (!(SIO[CH].flag & TSF_INIT))     /* Ȃ牽Ȃ */
        return;
    dis_int_sio();                      /* VA݋֎~ */
    sfr_outw(SCIF_SCSCR, 0x00);         /* M֎~ */

    /* ݒ` */

    def_inh(INT_ERIx, (T_DINH *)NADR);
    def_inh(INT_RXIx, (T_DINH *)NADR);
    def_inh(INT_TXIx, (T_DINH *)NADR);
    def_inh(INT_BRIx, (T_DINH *)NADR);

    SIO[CH].flag &= ~TSF_INIT;          /* ς݃tONA */
}

/*******************************************************************************
* VAP
*
*******************************************************************************/

ER get_sio(UB *c, TMO tmout)
{
    ER ercd;
    int sts;

    for (;;)
    {
        chg_ims(IP);

        /* Mobt@P */

        sts = get_rxbuf(c);

        if (sts != -1)              /* Mꍇ */
        {
            chg_ims(0);

            /* MG[ */

            if (sts & (FSR_TEND|FSR_RDF|FSR_FER|FSR_PER|FSR_BRK))
            {
                if (sts & FSR_TEND)         /* I[ot[TENDɊ蓖 */
                    ercd = EV_SIOOVF;
                else if (sts & FSR_RDF)     /* I[o[RDFɊ蓖 */
                    ercd = EV_SIOORN;
                else if (sts & FSR_BRK)
                    ercd = EV_SIOBRK;
                else if (sts & FSR_FER)
                    ercd = EV_SIOFRM;
                else /* FSR_PER */
                    ercd = EV_SIOPTY;
            }
            else
                ercd = E_OK;
            return ercd;
        }

        /* Mݑ҂ */

        SIO[CH].rxtid = vget_tid();
        chg_ims(0);
        ercd = tslp_tsk(tmout);
        SIO[CH].rxtid = 0;
        vcan_wup();                 /*  iwup_tsk ꂽꍇ̑΍ */
        if (ercd)
            return ercd;            /* ^CAEgI */
    }
}

/*******************************************************************************
* VAPo
*
*******************************************************************************/

ER put_sio(UB c, TMO tmout)
{
    ER ercd;

    for (;;)
    {
        chg_ims(IP);

        /* Mobt@ւPi[ */

        if (put_txbuf(c))           /* i[łꍇ */
        {   chg_ims(0);
            return E_OK;            /* I */
        }

        /* Mݑ҂ */

        SIO[CH].txtid = vget_tid();
        chg_ims(0);
        ercd = tslp_tsk(tmout);
        SIO[CH].txtid = 0;
        vcan_wup();                 /*  iwup_tsk ꂽꍇ̑΍ */
        if (ercd)
            return ercd;            /* ^CAEgI */
    }
}

/*******************************************************************************
* VAo͐
*
*******************************************************************************/

ER ctl_sio(UH fncd)
{
    UB c;

    chg_ims(IP);

    /* obt@NA */

    if (fncd & TSIO_RXCLR)
        clr_rxbuf();
    if (fncd & TSIO_TXCLR)
        clr_txbuf();

    /* u[NM */

    if (fncd & TSIO_SBON)
    {   fncd |= TSIO_TXD;
        sfr_setw(SCIF_SCSPTR, SPTR_SPB2DT|SPTR_SPB2IO);
        sfr_clrw(SCIF_SCSPTR, SPTR_SPB2DT);
    }
    if (fncd & TSIO_SBOFF)
    {   fncd |= TSIO_TXE;
        sfr_setw(SCIF_SCSPTR, SPTR_SPB2DT);
        sfr_clrw(SCIF_SCSPTR, SPTR_SPB2IO);
    }

    /* VA[hύX */

    if (fncd & (TSIO_RXE|TSIO_RXD|TSIO_TXE|TSIO_TXD))
    {   c = sfr_inw(SCIF_SCSCR);
        if (fncd & TSIO_RXE)        c |=  SCR_RE;
        if (fncd & TSIO_RXD)        c &= ~SCR_RE;
        if (fncd & TSIO_TXE)        c |=  SCR_TE;
        if (fncd & TSIO_TXD)        c &= ~SCR_TE;
        sfr_outw(SCIF_SCSCR, c);
    }

    chg_ims(0);
    return E_OK;
}

/*******************************************************************************
* VAo͏ԎQ
*
*******************************************************************************/

ER ref_sio(T_SIOS *pk_sios)
{
    int stat;

    chg_ims(IP);

    stat = get_stat();
    if (SIO[CH].txcnt != 0)
        stat &= ~TSIO_TXEMP;

    pk_sios->siostat = (UB)stat;
    pk_sios->rxlen   = SIO[CH].rxcnt;
    pk_sios->frbufsz = (UH)(TXBUFSZ - SIO[CH].txcnt);
    pk_sios->eotcnt  = SIO[CH].eotcnt;

    chg_ims(0);
    return E_OK;
}

/*******************************************************************************
* VAMobt@tbV
*
*******************************************************************************/

ER fls_sio(TMO tmout)
{
    ER ercd;

    for (;;)
    {
        chg_ims(IP);

        if (SIO[CH].txcnt == 0)
        {
            chg_ims(0);
            return E_OK;            /* I */
        }

        /* MIݑ҂ */

        SIO[CH].tetid = vget_tid();
        chg_ims(0);
        ercd = tslp_tsk(tmout);
        SIO[CH].tetid = 0;
        vcan_wup();                     /*  iwup_tsk ꂽꍇ̑΍ */
        if (ercd)
            return ercd;                /* ^CAEgI */
    }
}

/* end */
