#define __SH7262BOARD_IIC_C__
//---------------------------------------------------------------------------
//  FILE        :sh7262board_iic.c
//  DATE        :2010/12/18
//  DESCRIPTION :LED
//  CPU TYPE    :SH72620
//  AUTHOR      :SEgl(http://blogs.yahoo.co.jp/carcon999)
//---------------------------------------------------------------------------
#include "iodefine.h"
#include "sh7262board_iic.h"

//#define EEPROM_MEM_ADDR 	0x0000
//#define DEVICE_CODE 	0xA0 /* EEPROM device code :b'1010 */
//#define DEVICE_ADDR 	0x00 /* EEPROM device address:b'000 */
//#define IIC_DATA_WR 	0x00 /* Data write code :b'0 */
//#define IIC_DATA_RD 	0x01 /* Data read code :b'1 */
//#define IIC3_DATA 	10


//---------------------------------------------------------------------------
//
//  Abstract:   IIC
//
//  Parameters: Ȃ
//
//  Returns:    Ȃ
//
//  Note:       IIC̃`lQ𗘗p邽߂̏
//
//---------------------------------------------------------------------------
void IIC_Init(void)
{
	/* ---- STBCR5 ---- */
	CPG.STBCR5.BIT.MSTP55 = 0;		/* IIC3 `l2  */

	/* ---- PORT ---- */
	PORT.PECR1.BIT.PE4MD = 0x01;	/* SCL2 select */
	PORT.PECR1.BIT.PE5MD = 0x01;	/* SDA2 select */

	/* ----IIC31 module operation enabled ---- */
	IIC3_2.ICCR1.BIT.ICE = 1u;		/* IIC3 W[\ */
	IIC3_2.ICCR1.BIT.RCVD = 0u;		/* ̎Mp */
	IIC3_2.ICCR1.BIT.MST = 1u;		/* }X^I */
	IIC3_2.ICCR1.BIT.TRS = 1u;		/* MI */
	IIC3_2.ICCR1.BIT.CKS = 0xF;		/* ]NbN[gFP/432(83.3kHz) */

	/* ---IIC bus mode register (ICMR) setting --- */
	/*
	bit7 : MLS:0 --------------------- MSB first
	bit6-4 : Reserve:1 ----------------- Reserve bit
	bit3 : BCWP:0--------------------- Unsetting
	bit2-0 : BC0:0, BC1:0,BC0:0--------- IIC format 9-bit
	*/
	IIC3_2.ICMR.BYTE = 0x30u;
}

//---------------------------------------------------------------------------
//
//  Abstract:   Jns
//
//  Parameters: Ȃ
//
//  Returns:    Ȃ
//
//  Note:       Jn𔭍sA}X^M[hɐ؂ւ܂B
//
//---------------------------------------------------------------------------
void IIC_Send_Start(void)
{
	while(IIC3_2.ICCR2.BIT.BBSY == 1u){
	/* oX҂ */
	}
	
	IIC3_2.ICCR1.BIT.MST = 1u;	// }X^
	IIC3_2.ICCR1.BIT.TRS = 1u;	// M
	IIC3_2.ICCR2.BYTE = ((IIC3_2.ICCR2.BYTE & 0xbfu)|0x80u); /* Jns */
}

//---------------------------------------------------------------------------
//
//  Abstract:   ~s
//
//  Parameters: Ȃ
//
//  Returns:    Ȃ
//
//  Note:       ~𔭍sAX[uM[hɐ؂ւ܂B
//
//---------------------------------------------------------------------------
void IIC_Send_End(void)
{
	IIC3_2.ICSR.BIT.TEND = 0u;		/* TEND tONA */
	IIC3_2.ICSR.BIT.STOP = 0u;		/* STOP tONA */
	IIC3_2.ICCR2.BYTE &= 0x3fu;		/* ~s */

									/* oX҂ */
	while(IIC3_2.ICSR.BIT.STOP == 0u){
	}

	IIC3_2.ICCR1.BYTE &= 0xcfu;		/* X[uM[h */
	IIC3_2.ICSR.BIT.TDRE = 0u;		/* TDRE NA */
}

//---------------------------------------------------------------------------
//
//  Abstract:   1 oCgf[^M
//
//  Parameters: unsigned char data : Mf[^
//
//  Returns:    ACK L : E_OK
//              ACK  : E_ERR
//
//  Note:       ~𔭍sAX[uM[hɐ؂ւ܂B
//
//---------------------------------------------------------------------------
int IIC_Data_Send(unsigned char data)
{
	volatile int ack = E_ERR;
	
	while(IIC3_2.ICSR.BIT.TDRE == 0u){
	/* ICDRT ̃GveB҂ */
	}

	IIC3_2.ICDRT = data;
	while(IIC3_2.ICSR.BIT.TEND == 0u){
	/* M҂ */
	}

	if(IIC3_2.ICIER.BIT.ACKBR == 0u){
		ack = E_OK;
	}

	return(ack);
}

//---------------------------------------------------------------------------
//
//  Abstract:   1 oCgf[^M
//
//  Parameters: unsigned char* pdata : Mf[^
//
//  Returns:    ACK L : E_OK
//              ACK  : E_ERR
//
//  Note:       
//
//---------------------------------------------------------------------------
int IIC_Data_Read(unsigned char* pdata)
{
	// TEND̃NA
	IIC3_2.ICSR.BIT.TEND = 0u;

	// ICCR1TRSNAi}X^M[hցj
	IIC3_2.ICCR1.BIT.TRS = 0u;

	// TDRẼNA
	IIC3_2.ICSR.BIT.TDRE = 0u;
	
	// RCVDZbg
	IIC3_2.ICCR1.BIT.RCVD = 1u;
	
	// ACKBIT
	IIC3_2.ICIER.BIT.ACKBR = 1u;//1oCĝ

	// _~[f[^ǂݍ
	*pdata = IIC3_2.ICDRR;

	while(IIC3_2.ICSR.BIT.RDRF == 0u){
	/* M҂ */
	}

	// f[^ǂݍ
	*pdata = IIC3_2.ICDRR;
	
	// RCVDZbg
	IIC3_2.ICCR1.BIT.RCVD = 0u;

	return(E_OK);
}





