#define __SH7262BOARD_CAMCTRL_C__
//---------------------------------------------------------------------------
//  FILE        :sh7262board_camctrl.c
//  DATE        :2010/12/18
//  DESCRIPTION :J
//  CPU TYPE    :SH72620
//  AUTHOR      :SEgl(http://blogs.yahoo.co.jp/carcon999)
//---------------------------------------------------------------------------
#include "iodefine.h"
#include <machine.h>
#include "sh7262board_iic.h"
#include "W5300/lstring.h"
//#include "sh7262board_timer.h"

#define DEF_RETRY_MAX		(1000)	// ʐMgCő吔
#define DEF_IIC_CAM_ADDR	(0x54)	// JIICAhX
#define DEF_IIC_EEPROM_ADDR	(0xA0)	// EEPROMAhX







/*""FUNC COMMENT""**************************************************************
* ID :
* Outline : }X^M[h
*------------------------------------------------------------------------------
* Include : iodefine.h
*------------------------------------------------------------------------------
* Declaration : int io_iic3_data_receive(unsigned char* r_buf,
* : unsigned int r_size);
*------------------------------------------------------------------------------
* Description : }X^M[hɐݒ肵Ar_sizeŎw肵oCg
* : MsAMf[^r_bufɊi[܂B
* : w萔̎MAX[uM[hɐ؂ւ܂B
*------------------------------------------------------------------------------
* Argument : unsigned char* r_buf : ǂݍ݃f[^i[
* : unsigned int r_size : ǂݍ݃f[^TCY
*------------------------------------------------------------------------------
* Return Value : E_OK
*------------------------------------------------------------------------------
* Note : None
*""FUNC COMMENT END""**********************************************************/
int io_iic3_data_receive(unsigned char* r_buf,unsigned int r_size)
{
	int cnt, mask;
	unsigned char dummy;
	mask = get_imask();
//	set_imask(15); /*  荞݋֎~  */
	/* ==== }X^M[h(AM)ݒ ==== */
	IIC3_2.ICSR.BIT.TEND = 0u; /* TENDNA */
	IIC3_2.ICCR1.BIT.MST = 1u; /* }X^[h */
	IIC3_2.ICCR1.BIT.TRS = 0u; /* M[h */
	IIC3_2.ICSR.BIT.TDRE = 0u; /* TDRENA */
	IIC3_2.ICCR1.BIT.RCVD = 1u; /* AM֎~ */
	/* ==== MJni1oCĝ݂̏ꍇj ==== */
	if(r_size == 1){ /* 1oCgM */
		IIC3_2.ICIER.BIT.ACKBT = 1u; /* ANmbWݒ"H" */
		dummy = IIC3_2.ICDRR; /* _~[[h */
//		set_imask(mask); /*  荞݋  */	
	}
	/* ==== MJni2oCgȏ̏ꍇj ==== */
	else{
		IIC3_2.ICIER.BIT.ACKBT = 0u; /* ANmbWݒ"L" */
		dummy = IIC3_2.ICDRR; /* _~[[h */
//		set_imask(mask); /*  荞݋  */
		/* ==== 2oCgcăf[^[h ==== */
		cnt = r_size;
		while( cnt > 2 ){
			/* ---- 1oCgM҂ ---- */
			while(IIC3_2.ICSR.BIT.RDRF == 0u){
			/* wait */
			}
			/* ---- f[^[h ---- */
			*r_buf++ = IIC3_2.ICDRR;
			cnt--;
		}
//		set_imask(15); /*  荞݋֎~  */
		/* ==== ŏIoCg-1̎M҂ ==== */
		while(IIC3_2.ICSR.BIT.RDRF == 0u){
		/* wait */
		}
		/* ==== ŏIoCg̎MJnOɃANmbW"H"ɐݒj==== */
		IIC3_2.ICIER.BIT.ACKBT = 1u;
//		set_imask(mask); /*  荞݋  */
		/* ==== ŏIoCg̎MJniŏIoCg-1̃f[^[hj ==== */
		*r_buf++ = IIC3_2.ICDRR;
	}
	/* ==== ŏIoCgM҂==== */
	while(IIC3_2.ICSR.BIT.RDRF == 0u){
	/* wait */
	}
	/* ==== ~𔭍s ==== */
	/* ---- SCL9NbNڂ̗҂ ---- */
	while(IIC3_2.ICCR2.BIT.SCLO == 1u){ /* Technical Update [TN-MC*-A020A/J] */
	/* wait */
	}
	/* ---- sJn ---- */
	IIC3_2.ICSR.BIT.STOP = 0u; /* STOPtONA */
	IIC3_2.ICCR2.BYTE &= 0x3fu; /* ~s */
	/* ---- ҂ ---- */
	while(IIC3_2.ICSR.BIT.STOP == 0u){
	/* wait */
	}
	/* ==== ŏIoCg̃f[^[h==== */
	*r_buf = IIC3_2.ICDRR;
	/* ==== X[uM[hɖ߂ ==== */
	IIC3_2.ICCR1.BIT.RCVD = 0u; /* RCVDNA */
//	IIC3_2.ICCR1.BYTE &= 0xcfu; /* X[uM[h */
	return(E_OK);
}




int Get_ii2_data(_UBYTE* pdata)
{
	int ack = E_OK;
	int i;


	for(i = 0 ; i < DEF_RETRY_MAX ; i++)
	{
		// IICJn
		IIC_Send_Start();

		// X[ufoCX̃AhX
		ack = IIC_Data_Send(0xa2);
		if(ack == E_ERR){
			// IICI
			IIC_Send_End();
			continue;
		}
		// 
		ack = IIC_Data_Send(0x0);//Address
		if(ack == E_ERR){
			// IICI
			IIC_Send_End();
			continue;
		}
//		Cpu_Wait1ms(5);
		// IICI
		IIC_Send_End();

		// IICJn
		IIC_Send_Start();
		// X[ufoCX̃AhX
		ack = IIC_Data_Send(0xa2 + 1);
		if(ack == E_ERR){
			// IICI
			IIC_Send_End();
			continue;
		}
		io_iic3_data_receive(pdata,16);
//		Cpu_Wait1ms(5);

		// IICI
//		IIC_Send_End();
		break;
	};

	return ack;
}
int Set_ii2_data(_UBYTE address,_UBYTE data)
{
	int ack = E_OK;
	int i,t;


	for(i = 0 ; i < DEF_RETRY_MAX ; i++)
	{
		// IICJn
		IIC_Send_Start();

		// X[ufoCX̃AhX
		ack = IIC_Data_Send(0xa2);
		if(ack == E_ERR){
			// IICI
			IIC_Send_End();
			continue;
		}
		// 
		ack = IIC_Data_Send(address);//Address
		if(ack == E_ERR){
			// IICI
			IIC_Send_End();
			continue;
		}
		// 
		ack = IIC_Data_Send(data);//Address
		if(ack == E_ERR){
			// IICI
			IIC_Send_End();
			continue;
		}
		//Cpu_Wait1ms(5);
		// IICI
		IIC_Send_End();
		//Cpu_Wait1ms(5);

		break;
	};

	return ack;
}


void iic_rtc_test(int iord)
{
   unsigned char rtc_buf[50];
   int i;
   int year,month,day,hour,minute,second;
   
	IIC_Init();
	
	
	if(iord){
	    Set_ii2_data(8,0x11);  //Year
   		Set_ii2_data(7,0x08);   //Month
   		Set_ii2_data(5,0x24);   //Day
   		Set_ii2_data(4,0x19);  //H
   		Set_ii2_data(3,0x39);  //M
   		Set_ii2_data(2,0x0);   //S
	}
	
  /* 
   Set_ii2_data(8,0x13);
   Set_ii2_data(7,0x12);
   Set_ii2_data(5,0x31);
   Set_ii2_data(4,0x23);
   Set_ii2_data(3,0x59);
   Set_ii2_data(2,0x30);
   */
  
   /*
   Set_ii2_data(8,0x11);  //Year
   Set_ii2_data(7,0x5);   //Month
   Set_ii2_data(5,0x20);   //Day
   Set_ii2_data(4,0x17);  //H
   Set_ii2_data(3,0x32);  //M
   Set_ii2_data(2,0x0);   //S
   */
   
   for(;;){
     Get_ii2_data(rtc_buf);
     year = rtc_buf[8] & 0xff;
     month = rtc_buf[7] & 0x1f;
     day = rtc_buf[5] & 0x3f;
     hour = rtc_buf[4] & 0x3f;
     minute = rtc_buf[3] & 0x7f;
     second = rtc_buf[2] & 0x7f;
     
/*
	 for(i=0;i<10;i++){
	 	w_printf("%02x ",rtc_buf[i]);
	 }
*/
	w_printf("%02x/%02x/%02x %02x:%02x:%02x ",year,month,day,hour,minute,second  );
	 w_printf("\r\n");
	 //Cpu_Wait1ms(100);
	 delay_ms(100);
     
   }
   
   
   
	
/*
	for(;;){
	
	for(i=0;i<20;i++)
	{
	  w_printf("TAC INC. \r\n");
	  w_printf("  %02x \r\n",i  );
	}
	
	}
*/

}



