#define __SH7262BOARD_TIMER_C__
//---------------------------------------------------------------------------
//  FILE        :sh7262board_timer.c
//  DATE        :2010/6/13
//  DESCRIPTION :^C}[
//  CPU TYPE    :SH72620
//  AUTHOR      :SEgl(http://blogs.yahoo.co.jp/carcon999)
//---------------------------------------------------------------------------
#include "iodefine.h"
#include "define.h"
//#include "sh7262board_led.h"
#include "sh7262board_sd.h"
#include <machine.h>

#define DIO_PA (*(volatile unsigned char *)(0x30000640))
#define DIO_PB (*(volatile unsigned char *)(0x30000642))
#define DIO_PC (*(volatile unsigned char *)(0x30000644))
#define DIO_PW (*(volatile unsigned char *)(0x30000646))


typedef struct timer_table{
	_UWORD countmaster;
	_UWORD regtime;
	_BOOL  loop;
	_UBYTE dammy;
	_PCALLBACKFUNC pFunc;
}TIMER_TABLE;

//fBCJE^
volatile _UWORD delay_counter;

// ^C}[JE^
volatile _UWORD timer_counter;

// ^C}[ptO
volatile _UWORD timer_use;

// ^CAEgtO
volatile _UWORD timer_time_out;

// ^C}[e[u
volatile TIMER_TABLE timer_table[TIMER_USEMAX];


volatile int m1_cnt,m100_cnt;

volatile int pwm_cmp_1,pwm_cmp_2;
volatile int pwm_cnt_1,pwm_cnt_2;

volatile int pa_data = 1;

void delay_ms(int ms){
	delay_counter=ms;
	while(delay_counter!=0);	
}

//---------------------------------------------------------------------------
//
//  Abstract:   ^C}̏
//
//  Parameters: Ȃ
//
//  Returns:    Ȃ
//
//  Note:       ^C}O^C}[ƂėpB
//
//---------------------------------------------------------------------------
void Timer_Init(void)
{	
	// CMTCl[u
	CPG.STBCR7.BYTE = CPG.STBCR7.BYTE & 0xFB;

	// RyA}b`^C}0 荞݃x1
	INTC.IPR10.BIT._CMT0 = 1;

	// JEg~
	CMT.CMSTR.WORD = 0;
	
	// 荞݃Cl[u P/32
	CMT.CMCSR0.WORD = 0x0041;
	
	CMT.CMCNT0.WORD = 0;
	CMT.CMCOR0.WORD = TIMER_COUNT;

	// ^C}[e[ȕ
	timer_counter = 0;
	timer_use = 0x0000;
	timer_time_out = 0x0000;
	memset(timer_table, 0x00, sizeof(timer_table));

	// `l0JEgJn
	CMT.CMSTR.WORD  = 1;
}

//---------------------------------------------------------------------------
//
//  Abstract:   ^C}[̓o^
//
//  Parameters: id        : ^C}[ID
//				count     : ^CAEg(ms)
//				loopflag  : JԂtO
//              pFunc     : ^CAEgR[obN֐
//
//  Returns:    Ȃ
//
//  Note:       ^CAEgŌĂяo֐o^B
//
//---------------------------------------------------------------------------
void Timer_Set(_UWORD id, _UWORD count, _BOOL loopflag, void* pFunc)
{	
	// ^CAEg̓o^
	timer_table[id].countmaster = count;
	timer_table[id].regtime = timer_counter;
	timer_table[id].pFunc = (_PCALLBACKFUNC)pFunc;
	timer_table[id].loop = loopflag;

	// ^C}ptOON
	timer_use |= (0x0001 << id);	
	
	// ^CAEgtONA
	timer_time_out &= ~(0x0001 << id);
}

//---------------------------------------------------------------------------
//
//  Abstract:   ^C}[̉
//
//  Parameters: id : ^C}[ID
//
//  Returns:    Ȃ
//
//  Note:       ^CAEgŌĂяo֐o^B
//
//---------------------------------------------------------------------------
void Timer_Clear(_UWORD id)
{	
	// ^C}ptOOFF
	timer_use &= ~(0x0001 << id);

	// ^CAEg̃NA
	timer_table[id].countmaster = 0;
	timer_table[id].regtime = 0;
	timer_table[id].pFunc = NULL;
	timer_table[id].loop = FALSE;
}


//---------------------------------------------------------------------------
//
//  Abstract:   ^CAEg`FbN
//
//  Parameters: id : ^C}[ID
//
//  Returns:    0ȊȌꍇ̓^CAEg
//
//  Note:       wID̃^C}[^CAEgĂ邩`FbNB
//
//---------------------------------------------------------------------------
_UWORD Timer_TimeoutCheck(_UWORD id)
{
	// ^CAEgtO`FbNB
	_UWORD mask = 0x0001 << id;
	_UWORD ret = timer_time_out & mask;
	
	// ^CAEgtO̓NAB
	timer_time_out &= ~mask;
	
	return ret;
}

//---------------------------------------------------------------------------
//
//  Abstract:   ^C}[C
//
//  Parameters: Ȃ
//
//  Returns:    Ȃ
//
//  Note:       C[vŌĂяoƁB
//
//---------------------------------------------------------------------------
void Timer_Main(void)
{
	_UWORD use;
	int i;

	// ^C}[gp̏ꍇ͏ȂB
	if(0 == timer_use)
	{
		goto EXIT;
	}

	use = timer_use;

	// ^CAEg̃`FbN	
	for(i = 0 ; i < TIMER_USEMAX ; i++)
	{
		// p^C}[𒲂ׂ
        if(use & 0x0001)
		{
			_UWORD work = timer_counter - timer_table[i].regtime;

			// ^CAEgԂɓBĂꍇ̓^CAEgtOONB
			if(work > timer_table[i].countmaster)
			{
				// ^CAEg֐o^ĂΌĂяoB
				if(timer_table[i].pFunc)
				{
					(*timer_table[i].pFunc)();	
				}
				// ^CAEg֐o^ĂȂꍇ́AtÔONB
				else
				{
					timer_time_out |= (0x0001 << i);
				}
				
				// [v̏ꍇ͌JԂ^C}[NB
				if(timer_table[i].loop)
				{
					// ^CAEg̍ēo^
					timer_table[i].regtime = timer_counter;
				}
				else
				{
					// ^CAEg̃NA
					timer_table[i].countmaster = 0;
					timer_table[i].regtime = 0;
					// ^C}ptOOFF
					timer_use &= ~(0x0001 << i);
				}
			}
		}
		
		// EVtgŏԂɒׂ
		use >>= 1;
	}
	
EXIT:;

	return;
}

//---------------------------------------------------------------------------
//
//  Abstract:   ^C}̊荞ݏ
//
//  Parameters: Ȃ
//
//  Returns:    Ȃ
//
//  Note:       Wݒł͂PŌĂяoB
//              d͎{ȂƁB
//
//---------------------------------------------------------------------------
void Timer_Interrupt(void)
{
	if(delay_counter>0)delay_counter--;
	
	timer_counter++;
	
	if(m1_cnt > 0){
		m1_cnt--;
	}
	//state_mp3();
	//
	//
	
	if(++m100_cnt >= 100){
		m100_cnt = 0;
		
		pa_data = DIO_PA & 0xff;
		pa_data <<= 1;
		if(pa_data == 0x100) pa_data = 1;
		DIO_PA = pa_data;
		
		pa_data = DIO_PB & 0xff;
		pa_data <<= 1;
		if(pa_data == 0x100) pa_data = 1;
		DIO_PB = pa_data;
		
		pa_data = DIO_PC & 0xff;
		pa_data <<= 1;
		if(pa_data == 0x100) pa_data = 1;
		DIO_PC = pa_data;
	}
	
	
	
	// SDJ[h̃^C}ĂяoB
	Sd_TimerInterrupt();
	
	// 荞݃NA
	CMT.CMCSR0.BIT.CMF = 0;
}
