/****************************************************************************
* NORTi4 TvvO (Interface June 2010 t^{[h)                *
*                                                                           *
*  Copyright (c) 2010, MiSPO Co., Ltd.                                      *
*  All rights reserved.                                                     *
*                                                                           *
* 2010-09-24 Created                                                     SZ *
****************************************************************************/

#include "kernel.h"
//#include "sh7262.h"
#include "iodefine.h"
//#include <machine.h>
//#include <stdlib.h>
//#include <stdio.h>
//#include <stdarg.h>
//#include <stdlib.h>
//#include <string.h>

#include "W5300/lstring.h"


#define tac_sample       //tac sample



/* IuWFNgID */

#define TSK_MAIN    1       /* Main task ID */
#define TSK_SUB     2       /* Sub task ID */
#define TSK_RCV1    3       /* CH2 Receive task ID */
#define TSK_SND1    4       /* CH2 Send task ID */
#define TSK_RCV2    5       /* CH3 Receive task ID */
#define TSK_SND2    6       /* CH3 Send task ID */
#define TSK_LED     7       /* LED task ID */
#define FLG_TST     1       /* Event flag ID */
#define SEM_TST     1       /* Semaphore ID */
#define MBX_COM     1       /* Mail box ID */
#define MPF_COM     1       /* Memory pool ID */

/* RtBO[V */

#define TSKID_MAX   7       /* Maximum ID for task */
#define SEMID_MAX   1       /* Maximum ID for semaphore */
#define FLGID_MAX   1       /* Maximum ID for event flag */
#define MBXID_MAX   2       /* Maximum ID for mail box */
#define MBFID_MAX   1       /* Maximum ID for message buffer */
#define PORID_MAX   1       /* Maximum ID for rendevouz port */
#define MPLID_MAX   1       /* Maximum ID for valiable length memory pool */
#define MPFID_MAX   1       /* Maximum ID for fixed length memory pool */
#define DTQID_MAX   1       /* Maximum ID for data queue */
#define MTXID_MAX   1       /* Maximum ID for mutex */
#define ISRID_MAX   1       /* Maximum ID for interrupt service routine */
#define SVCID_MAX   1       /* Maximum ID for superviser call */
#define CYCNO_MAX   1       /* Maximum ID for cycric handler */
#define ALMNO_MAX   1       /* Maximum ID for alarm handler */

#define ISTKSZ      1024    /* Stack size for Interrupt Handlers */
#define TSTKSZ      1024    /* Stack size for Time Event Handlers */

#include "nocfg4.h"

#include "nosio.h"

/* bZ[W\ */

#define COMBUFSZ    256
#define NCOMMPF     32

typedef struct t_commsg
{
    struct t_commsg *next;
    B buf[COMBUFSZ];

} T_COMMSG;

/* IuWFNg */

TASK MainTask(void);
TASK SubTask(void);
TASK RcvTask(INT);
TASK SndTask(INT);
TASK LedTask(void);

const T_CTSK ctsk_main = { TA_HLNG, NULL, MainTask, 7, 512, NULL, "MainTask" };
const T_CTSK ctsk_sub  = { TA_HLNG, NULL, SubTask,  6, 512, NULL, "SubTask" };
const T_CTSK ctsk_rcv1 = { TA_HLNG, NULL, RcvTask,  1, 512, NULL, "RcvTask1" };
const T_CTSK ctsk_snd1 = { TA_HLNG, NULL, SndTask,  2, 512, NULL, "SndTask1" };
//const T_CTSK ctsk_rcv2 = { TA_HLNG, NULL, RcvTask,  1, 512, NULL, "RcvTask2" };
//const T_CTSK ctsk_snd2 = { TA_HLNG, NULL, SndTask,  2, 512, NULL, "SndTask2" };
const T_CTSK ctsk_led  = { TA_HLNG, NULL, LedTask,  2, 512, NULL, "LedTask" };
const T_CMBX cmbx      = { TA_TFIFO|TA_MFIFO, 0, NULL, "mbx" };
const T_CMPF cmpf      = { TA_TFIFO, NCOMMPF, sizeof (T_COMMSG), NULL, "mpf" };
const T_CSEM csem      = { TA_TFIFO, 0, 255, "sem1" };
const T_CFLG cflg      = { TA_WMUL, 0, "flag" };

const char title[] = "\n\n\r\
------------------------------------------------------------------------\r\n\
          NORTi Version 4 Sample Demonstration program                  \r\n\
                        for TAC T-SH2A board                            \r\n\
                                                                        \r\n\
 Program version 1.0                                                    \r\n\
------------------------------------------------------------------------\r\n\r\n";
const char echo_str[] = "Press any key to run the ECHO test program.\r\n\n";
const char *test_str[] = {"Test Application Program for SCIF Channel-0\r\n",
                          "Test Application Program for SCIF Channel-3\r\n"};


#ifdef tac_sample

#define TSK_MAIN_tac    1       /* Main task ID */
#define TSK_Msec    2       /*  task ID */

TASK MainTask_tac(void);
TASK MsecTask(void);

const T_CTSK ctsk_main_tac = { TA_HLNG, NULL, MainTask_tac, 7, 512, NULL, "MainTask_tac" };
const T_CTSK ctsk_msec  = { TA_HLNG, NULL, MsecTask,  2, 512, NULL, "MsecTask" };



#endif


/*****************************************************************************
* peripheral ̗
*
******************************************************************************/

#define SetCCR1(x) ((void(*)(_UDWORD))((_UDWORD)SetCCR1_proc + 0x20000000))(x)	/* CCR1ւ̏(LbVGAŎs) */
void SetCCR1_proc (_UDWORD val)	/* CCR1ւ̏ */
{
	CCNT.CCR1.LONG;
	CCNT.CCR1.LONG;
	CCNT.CCR1.LONG = val;
	CCNT.CCR1.LONG;
	CCNT.CCR1.LONG;
}

#define SDRAM_MODE (*(volatile unsigned short *)(0xfffc5040))
void ini_pio(void)
{
	volatile int j = 100000; /* 200usec wait count */
	
	// CPUōx144MHzɕύXB
	CPG.FRQCR.BIT.IFC = 0;	//  1/3 -> 1/1{
	
	// d̓[hֈڍsĂVDC3ւ̃NbNpB	
	CPG.STBCR7.BIT.MSTP74 = 0;
	
	// DMAC ̃W[Xgbv
	CPG.STBCR2.BIT.MSTP8 = 0;
	


	//Bus Init.
	
	
	//D15 - D0
	PORT.PDCR3.WORD = 0x1111;  // PD15,PD14,PD13,PD12
	PORT.PDCR2.WORD = 0x1111;  // PD11,PD10,PD9,PD8
	PORT.PDCR1.WORD = 0x1111;  // PD7,PD6,PD5,PD4
	PORT.PDCR0.WORD = 0x1111;  // PD3,PD2,PD1,PD0
	
	//A15 - A1
	PORT.PBCR4.BIT.PB16MD = 0x1;  // PB16 (PC104 A15)
	PORT.PBCR3.WORD = 0x1111;  // PB15,PB14,PB13,PB12
	PORT.PBCR2.WORD = 0x1111;  // PB11,PB10,PB9,PB8
	PORT.PBCR1.WORD = 0x1111;  // PB7,PB6,PB5,PB4
	PORT.PBCR0.WORD = 0x1110;  // PB3,PB2,PB1
	
	PORT.PBCR5.BIT.PB22MD = 0x2; //PB22:_CS4 PC104 BUS
	
	PORT.PJCR0.BIT.PJ2MD = 0x3;  // PJ2:_CS2 USB STORAGE
	
	PORT.PCCR0.BIT.PC0MD = 0x1;  // PC0:_CS0 LAN W5300
	PORT.PCCR0.BIT.PC1MD = 0x1;  // PC1:_RD
	PORT.PCCR0.BIT.PC2MD = 0x1;  // PC2:RD/_WR
	PORT.PCCR0.BIT.PC3MD = 0x1;  // PC3:_WE0/_DQML
	
	PORT.PCCR1.BIT.PC4MD = 0x1;  // PC4:_WE1/_DQMU
	PORT.PCCR1.BIT.PC5MD = 0x1;  // PC5:_RAS
	PORT.PCCR1.BIT.PC6MD = 0x1;  // PC6:_CAS
	PORT.PCCR1.BIT.PC7MD = 0x1;  // PC7:CKE
		
	PORT.PCCR2.BIT.PC8MD = 0x1;  // PC8:_CS3 SDRAM
	
	//CS0 LAN W5300
	BSC.CS0BCR.BIT.BSZ = 0x2; //16bit
	
	//CS2 USB HOST STORAGE
	BSC.CS2BCR.BIT.BSZ = 0x2; //16bit
	//BSC.CS2WCR.NORMAL.BIT.WR = 0xc; //wait 
	
	
	//CS4 PC104BUS
	//BSC.CS4BCR.BIT.BSZ = 0x2; //16bit
	BSC.CS4BCR.BIT.BSZ = 0x1; //8bit
	//BSC.CS4WCR.NORMAL.LONG = 0x00001d03ul; //
//	BSC.CS4WCR.NORMAL.LONG = 0x00001d03ul; //
//	BSC.CS4BCR.LONG = 0x36db0200ul; //
//	BSC.CMNCR.LONG = 0x00001010ul;
	
	//CS3 SDRAM
	/* ==== 200us interval elapsed ? ==== */
	while(j-- > 0){; /* wait */
	}
	/* ==== CS3BCR settings ==== */
	BSC.CS3BCR.LONG = 0x00004400ul;
	/*
	Idle Cycles between Write-read Cycles
	and Write-write Cycles : 0 idle cycles
	Memory type :SDRAM
	Data Bus Size : 16-bit
	*/
	/* ==== CS3WCR settings ==== */
	BSC.CS3WCR.SDRAM.LONG = 0x0000288aul;
	/*
	Precharge completion wait cycles: 1 cycle
	Wait cycles between ACTV command and READ(A)/WRITE(A) command : 2 cycles
	CAS latency for Area 3 : 2 cycles
	Auto-precharge startup wait cycles : 1 cycle
	Idle cycles from REF command/self-refresh
	Release to ACTV/REF/MRS command : 5 cycles
	*/
	/* ==== SDCR settings ==== */
	//BSC.SDCR.LONG = 0x00000809ul;
	BSC.SDCR.LONG = 0x00000811ul;
	/*
	Refresh Control :Refresh
	RMODE :Auto-refresh is performed
	BACTV :Auto-precharge mode
	Row address for Area 3 : 13-bit
	Column Address for Area 3 : 9-bit
	*/
	/* ==== RTCOR settings ==== */
	BSC.RTCOR.LONG = 0xa55a0046ul; 
	/*
	15.625us/222ns = 70(0x46)cycles per refresh
	*/
	
	/* ==== RTCSR settings ==== */
	BSC.RTCSR.LONG = 0xa55a0010ul;
	/*
	Initialization sequence start
	Clock select B-phy/16
	Refresh count :Once
	*/
	/* ==== Written in SDRAM Mode Register ==== */
	SDRAM_MODE = 0; 
	/*
	The writing data is arbitrary
	SDRAM mode register setting CS3 space
	Burst read (burst length 1)./Burst write
	*/
	

	
	
		/*--- PJDR0ݒ PJ8LED ---*/
	PORT.PJDR0.BIT.PJ8DR = 0; //
	PORT.PJDR0.BIT.PJ7DR = 1; //
	/*--- PJIOR0ݒ PJ8LEDo͂ɐݒ ---*/
	PORT.PJIOR0.BIT.PJ8IOR = 1;
	PORT.PJIOR0.BIT.PJ7IOR = 1;
	/*--- PJCR2ݒ PJ8̐ݒ ---*/
	PORT.PJCR2.BIT.PJ8MD = 0;
	PORT.PJCR1.BIT.PJ7MD = 0;


	// LbVL
	SetCCR1(0x0000090B);


}
unsigned char scif0_get(void){
   T_SIOS sios;
   ER ercd;
   unsigned char c;

   while(1){
        ref_sio(0, &sios);
        if (sios.rxlen != 0){
        	ercd = get_sio(0, &c, 1000/MSEC);
			return c;
		}
   }
}


void scif0_put(char c){
   put_sio(0, (UB)(c), TMO_FEVR);
}	
void puts_(unsigned char *buf){
    int i;
	for (i=0; buf[i] != 0; i++) {
        put_sio(0, (UB)(buf[i]), TMO_FEVR);
	} 
}


/*****************************************************************************
* C^XN
*
******************************************************************************/

TASK MainTask(void)
{
    UINT ptn;

    /* ^XNN */

    sta_tsk(TSK_SUB, 0);
    sta_tsk(TSK_RCV1, 0);
    sta_tsk(TSK_SND1, 0);
//    sta_tsk(TSK_RCV2, 1);
//    sta_tsk(TSK_SND2, 1);
    sta_tsk(TSK_LED, 0);

    /* SubTask ƃVXeR[̃eXg */

    for (;;) {
        slp_tsk();
        slp_tsk();
        dly_tsk(10/MSEC);
        wai_sem(SEM_TST);
        wai_flg(FLG_TST, 0x0001, TWF_ORW, &ptn);
        clr_flg(FLG_TST, 0x0000);
    }
}

/*****************************************************************************
* Tu^XN
*
******************************************************************************/

TASK SubTask(void)
{
    /* MainTask Dx */

    chg_pri(TSK_SELF, 8);

    /* MainTask ƃVXeR[̃eXg */

    for (;;) {
        wup_tsk(TSK_MAIN);
        rel_wai(TSK_MAIN);
        tslp_tsk(20/MSEC);
        sig_sem(SEM_TST);
        set_flg(FLG_TST, 0x0001);
    }
}

/*****************************************************************************
* M^XN
*
******************************************************************************/

TASK RcvTask(INT ch)
{
    T_COMMSG *msg;
    T_SIOS sios;
    ER ercd;
    UINT i;
    UB c;

    /* initialize */

    ini_sio(ch, "38400 B8 PN S1 XON");
    ctl_sio(ch, TSIO_RXE|TSIO_TXE|TSIO_RTSON);

    for (i=0; title[i]!=0; i++) {
        put_sio(ch, (UB)(title[i]), TMO_FEVR);
    }
    for (i=0; test_str[ch][i] != 0; i++) {
        put_sio(ch, (UB)test_str[ch][i], TMO_FEVR);
    }
    for (i=0; echo_str[i] != 0; i++) {
        put_sio(ch, (UB)echo_str[i], TMO_FEVR);
    }

    for (i = 0;;) {
        ref_sio(ch, &sios);
        if (sios.rxlen != 0)
            break;
        dly_tsk(1000/MSEC);
        put_sio(ch, (UB)('0' + i), 10/MSEC);
        if (++i > 9)
            i = 0;
    }

    for (;;) {
        /* Get memory block */

        get_mpf(MPF_COM, &msg);

        /* Received one line */

        for (i = 0;;) {
            ercd = get_sio(ch, &c, 1000/MSEC);
            if (ercd == E_TMOUT)
                break;
            if (c == '\n')
                continue;
            msg->buf[i] = c;
            if ((++i >= COMBUFSZ - 1) || (c == '\r'))
                break;
        }
        msg->buf[i] = '\0';

        /* Send message */

        snd_mbx(MBX_COM+ch, msg);
    }
}

/*****************************************************************************
* M^XN
*
******************************************************************************/

TASK SndTask(INT ch)
{
    T_COMMSG *msg;
    UINT i;
    UB c;

    for (;;) {
        /* Wait message */

        rcv_mbx(MBX_COM+ch, &msg);

        /* Send 1 line */

        for (i = 0;;) {
            c = msg->buf[i++];
            if (c == '\0')
                break;
            put_sio(ch, c, TMO_FEVR);
            if (c == '\r')
                put_sio(ch, '\n', TMO_FEVR);
        }

        /* Release memory block */

        rel_mpf(MPF_COM, msg);

        /* Wait completion */

        fls_sio(ch, TMO_FEVR);
    }
}

/*****************************************************************************
* LED ^XN
*
******************************************************************************/

TASK LedTask(void)
{
    UB cnt = 0;
	int i;

    for (;;) {
        dly_tsk(100/MSEC);
		
		shift_dio();

        switch(cnt++ & 1) {
        case 0 : /* LED  */
			PORT.PJDR0.BIT.PJ7DR = 1; //
			PORT.PJDR0.BIT.PJ8DR = 0; //
            break;
        default : /* LED _ */
			PORT.PJDR0.BIT.PJ7DR = 0; //
			PORT.PJDR0.BIT.PJ8DR = 1; //
            break;
        }
    }
}
extern unsigned short Timer;
void fook_cmt0(void){
		Timer++;
}	


/*****************************************************************************
* main
*
******************************************************************************/
#ifndef tac_sample
int main(void)
{
    /* VXe */

    sysini();
    ini_pio();

    /* ^XN */

    cre_tsk(TSK_MAIN, &ctsk_main);
    cre_tsk(TSK_SUB, &ctsk_sub);
    cre_tsk(TSK_RCV1, &ctsk_rcv1);
    cre_tsk(TSK_SND1, &ctsk_snd1);
//   cre_tsk(TSK_RCV2, &ctsk_rcv2);
//   cre_tsk(TSK_SND2, &ctsk_snd2);
    cre_tsk(TSK_LED, &ctsk_led);

    /* ^XNȊÕIuWFNg */

    cre_sem(SEM_TST,   &csem);  /* Z}tH */
    cre_flg(FLG_TST,   &cflg);  /* CxgtO */
    cre_mpf(MPF_COM,   &cmpf);  /* Œ蒷v[ */
    cre_mbx(MBX_COM+0, &cmbx);  /* C{bNX */
    cre_mbx(MBX_COM+1, &cmbx);  /* C{bNX */

    /* ^XNN */

    sta_tsk(TSK_MAIN, 0); 
	

    /* VXeN */

    intsta();                   /* ^C}݂N */
    syssta();                   /* }`^XNֈڍs */


    return 0;
}
#endif
//******************************************************************************/
//* 
//******************************************************************************/
#ifdef tac_sample
int main(void)
{
    /* VXe */

    sysini();
    ini_pio();

    /* ^XN */

    cre_tsk(TSK_MAIN_tac, &ctsk_main_tac);
    cre_tsk(TSK_LED, &ctsk_led);
    cre_tsk(TSK_Msec, &ctsk_msec);

    /* ^XNN */

    sta_tsk(TSK_MAIN_tac, 0); 
	

    /* VXeN */

    intsta();                   /* ^C}݂N */
    syssta();                   /* }`^XNֈڍs */


    return 0;
}

TASK MainTask_tac(void)
{
    UINT ptn;
	unsigned char buf[200];

    ini_sio(0, "38400 B8 PN S1");
    ctl_sio(0, TSIO_RXE|TSIO_TXE);

    //{[[g115200bps
	SCIF0.SCEMR.WORD = 0x0081;		// {[[gWFl[^{[hA
	SCIF0.SCBRR.BYTE = 25; //24MHz@/  115200 / 8 - 1 = @25

    /* ^XNN */
    sta_tsk(TSK_LED, 0);
    sta_tsk(TSK_Msec, 0); 

	
	tac_sample_main();
}

TASK MsecTask(void)
{
	int msec_cnt = 0;
    for (;;) {
        //if(++msec_cnt >= 10){
		//	msec_cnt = 0;
		//}	
		
	    
		disk_timerproc();
		
		dly_tsk(10/MSEC);
		
    }
}

#endif

/* end */
