
#include "iodefine.h"
#include <machine.h>
#include "sh7262board_iic.h"
#include "W5300/lstring.h"

#include "kernel.h"
#include "nosio.h"

//T-ADA16S BASE 0x380
#define ADU   (*(volatile unsigned char *)0x30000700)
#define ADL   (*(volatile unsigned char *)0x30000702)
#define ADSTS (*(volatile unsigned char *)0x30000704)

#define ISO_IN  (*(volatile unsigned char *)0x30000708)
#define ISO_OUT (*(volatile unsigned char *)0x3000070a)

#define DA_D_L  (*(volatile unsigned char *)0x3000070c)
#define DA_D_H  (*(volatile unsigned char *)0x3000070e)
#define LDAC_0  (*(volatile unsigned char *)0x30000710)
#define LDAC_1  (*(volatile unsigned char *)0x30000712)
#define DA_CS0  (*(volatile unsigned char *)0x30000714)
#define DA_CS1  (*(volatile unsigned char *)0x30000716)
#define SPI_STS (*(volatile unsigned char *)0x30000718)

void delay_tmp(void){
	volatile int i,t;
	
	for(i=0;i<10000;i++){
	;
	}

}

void set_da(int ch,int data){

	if(ch < 4) DA_CS0 = 0; //cs0:L
	else       DA_CS1 = 0; //cs1:L
		
	DA_D_H = ((ch << 6) & 0xc0) | ((data >> 8) & 0xf);
	DA_D_L = data & 0xff ; //start spi send
	while(SPI_STS & 0x80) ; //0.3usec
	
	if(ch < 4) {
		DA_CS0 = 1; //cs0:H
		LDAC_0 = 0; //latch
	}
	else{
	    DA_CS1 = 1; //cs1:H
		LDAC_1 = 0; //latch
	}
}


int addata(int a) //0 - 15
{
	ADSTS =  a;/* select ch.  */
	ADSTS =  a;/* select ch.  */
	ADSTS =  a;/* select ch.  */
	ADSTS =  a;/* select ch.  */
	ADU = 0; //Start ADconvert
	while((ADSTS & 0x80)){ ; }  /* converting */
	return( (ADU << 4) | ( (ADL >> 4) & 0xf) );
	
}	

void adin(void)
{
	int ch;
	unsigned char d;
    T_SIOS sios;
    ER ercd;
    UB c;
	
	while(1){
    	ref_sio(0, &sios);
    	if (sios.rxlen != 0){
       		ercd = get_sio(0, &c, 1000/MSEC);
		  	break;
		}
	
		for(ch = 0 ; ch < 16 ; ch ++ ){	
			w_printf("%03x ",addata(ch)); 
		}
		w_printf("%02x ",ISO_IN); 
		w_printf("\n\r");
		
		for(ch = 0 ; ch < 8 ; ch ++ ){	
			set_da(ch,addata(ch));
		}
		ISO_OUT = ISO_IN;
		
		//sleep(20);
		
	}
}
void adin2(void)
{
	int ch;
	unsigned char d;
    T_SIOS sios;
    ER ercd;
    UB c;


    while(1){
    	ref_sio(0, &sios);
    	if (sios.rxlen != 0){
       		ercd = get_sio(0, &c, 1000/MSEC);
		  	break;
		}
		w_printf("%04d ",addata(0)); 
		w_printf("\n\r");
	}
	
}


void test_da(void){
	int ch;
	int data;
	int i;
	unsigned char d;
    T_SIOS sios;
    ER ercd;
    UB c;
	
	//while(1){
	while(1){
    	ref_sio(0, &sios);
    	if (sios.rxlen != 0){
       		ercd = get_sio(0, &c, 1000/MSEC);
		  	break;
		}
		for(data = 0 ; data < 0x1000 ; data++ ){	
			for(i=0;i<8;i++){
			   set_da(i,data);
			}
			//set_da(0,data);
			/*
			set_da(1,data / 2);
			set_da(2,data / 3);
			set_da(3,data / 4);
			set_da(4,data / 5);
			set_da(5,data / 6);
			set_da(6,data / 7);
			set_da(7,data / 8);
			*/
		}
	}
}
void test_da2(void){
	int data = 0xfff;

	set_da(0,(data * 1) / 8 );
	set_da(1,(data * 2) / 8 );
	set_da(2,(data * 3) / 8 );
	set_da(3,(data * 4) / 8 );
	set_da(4,(data * 5) / 8 );
	set_da(5,(data * 6) / 8 );
	set_da(6,(data * 7) / 8 );
	set_da(7,(data * 8) / 8 );
	
}

int ada16s_main(void) {
	int	i, value;
	int n;
	unsigned char c;

	
	
	DA_CS0 = 1; //DA CS:H
	DA_CS1 = 1; //DA CS:H
	
	adin();
	adin2();
	test_da();
	test_da2();

}




