#include "kernel.h"
#include "nosio.h"
//#include "define.h"
#include "iodefine.h"
#include <machine.h>

#include "W5300/lstring.h"




void tac_sample_main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif


int sel_para;

extern int m1_cnt;
extern int cont_down_sts;

extern int pwm_cmp_1,pwm_cmp_2;

extern _UWORD delay_counter;


#define CYCLE 12000    //2kHz
#define DUTY  (CYCLE / 2)
#define WAIT (500)

////T104-DIO72
//0x30000000 + (BIO * 2)  BIO:0x320
#define DIO_PA1 (*(volatile unsigned char *)(0x30000640))
#define DIO_PB1 (*(volatile unsigned char *)(0x30000642))
#define DIO_PC1 (*(volatile unsigned char *)(0x30000644))
#define DIO_PW1 (*(volatile unsigned char *)(0x30000646))

#define DIO_PA2 (*(volatile unsigned char *)(0x30000648))
#define DIO_PB2 (*(volatile unsigned char *)(0x3000064A))
#define DIO_PC2 (*(volatile unsigned char *)(0x3000064C))
#define DIO_PW2 (*(volatile unsigned char *)(0x3000064E))

#define DIO_PA3 (*(volatile unsigned char *)(0x30000650))
#define DIO_PB3 (*(volatile unsigned char *)(0x30000652))
#define DIO_PC3 (*(volatile unsigned char *)(0x30000654))
#define DIO_PW3 (*(volatile unsigned char *)(0x30000656))


//T104-IO4032
//0x30000000 + (BIO:0x300 * 2)  BIO:0x300 
#define IO4032P1 (*(volatile unsigned char *)(0x30000600)) //IN
#define IO4032P2 (*(volatile unsigned char *)(0x30000602)) //IN
#define IO4032P3 (*(volatile unsigned char *)(0x30000604)) //IN
#define IO4032P4 (*(volatile unsigned char *)(0x30000606)) //IN
#define IO4032P5 (*(volatile unsigned char *)(0x30000608)) //IN
#define IO4032P6 (*(volatile unsigned char *)(0x3000060a)) //OUT
#define IO4032P7 (*(volatile unsigned char *)(0x3000060c)) //OUT
#define IO4032P8 (*(volatile unsigned char *)(0x3000060e)) //OUT
#define IO4032P9 (*(volatile unsigned char *)(0x30000610)) //OUT
#define IO4032CR (*(volatile unsigned char *)(0x30000612)) //OUT





void iic_rtc_test(int);





void shift_dio(void){
    static unsigned int pa_data;



//	if(++m100_cnt >= 100){
//		m100_cnt = 0;
		
		pa_data = DIO_PA1 & 0xff;
		pa_data <<= 1;
		if(pa_data == 0x100) pa_data = 1;
		DIO_PA1 = pa_data;
		
		pa_data = DIO_PB1 & 0xff;
		pa_data <<= 1;
		if(pa_data == 0x100) pa_data = 1;
		DIO_PB1 = pa_data;
		
		pa_data = DIO_PC1 & 0xff;
		pa_data <<= 1;
		if(pa_data == 0x100) pa_data = 1;
		DIO_PC1 = pa_data;
//	}
}


/*=== C֐ ===*/
void tac_sample_main(void)
{
	_UINT size = 0;
	int i,j;
    T_SIOS sios;
    ER ercd;
    UB c;
	
	int count =0;
	
	unsigned long cx,cy;
	unsigned int bluecount;
	unsigned long cx_e,cy_e;
	unsigned char d;
	
	
	
	DIO_PW1 = 0x80; //T104-DIO72 init.
	DIO_PW2 = 0x80; //T104-DIO72 init.
	DIO_PW3 = 0x80; //T104-DIO72 init.
	
	DIO_PA1 = 0x1;
	DIO_PB1 = 0x2;
	DIO_PC1 = 0x4;
	
	DIO_PA2 = 0x08;
	DIO_PB2 = 0x10;
	DIO_PC2 = 0x20;
	
	DIO_PA3 = 0x40;
	DIO_PB3 = 0x80;
	DIO_PC3 = 0x55;


	IO4032CR = 0x00; //T104-IO4032 init. P1-5:IN P6-9:OUT
	
	
	
	
	IO4032P6 = 0x12;
	IO4032P7 = 0x34;
	IO4032P8 = 0x56;
	IO4032P9 = 0x78;

	w_printf( "\n\r");

	w_printf( "P6:%2x ",IO4032P6);
	w_printf( "P7:%2x ",IO4032P7);
	w_printf( "P8:%2x ",IO4032P8);
	w_printf( "P9:%2x \n\r",IO4032P9);
	
	
	
	w_printf( "Hit any key to test program \n\r");
	w_printf( "a : max1270 \n\r");
	w_printf( "r : RTC write \n\r");
	w_printf( "t : RTC read  \n\r");
	w_printf( "w : W5300 \n\r");
	w_printf( "d : T-ADA16S \n\r");
	w_printf( "s : SDcard  \n\r");
	
	/*--- [v ---*/
	while(1){
		
		
        ref_sio(0, &sios);
        if (sios.rxlen != 0){
        	ercd = get_sio(0, &c, 1000/MSEC);
		   
       			 if(c == 'a') test_max1270();
			else if(c == 'r') iic_rtc_test(0);
			else if(c == 't') iic_rtc_test(1);
			else if(c == 'w') w5300_main();
			else if(c == 's') sd_main();
			else if(c == 'd') ada16s_main();

           	put_sio(0, c, 10/MSEC);
	    }
		 
		 
		 
		
		
        dly_tsk(10/MSEC);


/*
	    w_printf( "P1:%02x ",~IO4032P1);
	    w_printf( "P2:%02x ",~IO4032P2);
	    w_printf( "P3:%02x ",~IO4032P3);
	    w_printf( "P4:%02x ",~IO4032P4);
	    w_printf( "P5:%02x ",~IO4032P5);
		
    	w_printf( "P6:%02x ",IO4032P6);
	    w_printf( "P7:%02x ",IO4032P7);
	    w_printf( "P8:%02x ",IO4032P8);
	    w_printf( "P9:%02x ",IO4032P9);

    	w_printf( "\n\r");
 		
		
		
		
		if(SCIF2.SCFSR.WORD & 0x0001){
			d = SCIF2.SCFRDR.BYTE;
			SCIF2.SCFSR.BIT.DR = 0;	// MFIFO f[^GveBNA
			
			SCIF2.SCFTDR.BYTE = d;
			SCIF2.SCFSR.BIT.TDFE = 0;	// MFIFO f[^GveBNA
		}
		
		if(SCIF3.SCFSR.WORD & 0x0001){
			d = SCIF3.SCFRDR.BYTE;
			SCIF3.SCFSR.BIT.DR = 0;	// MFIFO f[^GveBNA
			
			SCIF3.SCFTDR.BYTE = d;
			SCIF3.SCFSR.BIT.TDFE = 0;	// MFIFO f[^GveBNA
		}
		
*/		
		

		
	}
}
